var newMessage;
var highlightCounter = 0;
var documentHeight = 0;
var selectedBookmark = -2;
var selectedSmartConnectionLink = 0;

var rowsCounter;
var dividerCounter;
var bookmarkSize;

// v1

function initGadget() {
	System.Gadget.Settings.write("installedVersion", System.Gadget.version.replace(/\./g,","));
}

function loadMain()
{
	try {
		init();
		checkShortcutCalls();
		
		for (var bookmarkSet in bookmarks) {
			if (typeof intelligentDialogContents[bookmarkSet] == "undefined"){
				intelligentDialogContents[bookmarkSet] = new Array();
			}
			for (i = 0; i < bookmarks[bookmarkSet].length; i++) {
				if (isDefaultBookmark(bookmarks[bookmarkSet][i])) {
					getIntelligentDialogContent(bookmarks[bookmarkSet][i]);
				}
			}
		}
		
		if (arrayLength(bookmarks) <= 1) {
			for (var bookmarkSet in bookmarks) {
				System.Gadget.Settings.write("selectedBookmarkSet", bookmarkSet);
			}
		}
		if (typeof System.Gadget.Settings.read("selectedBookmarkSet") != "undefined" && bookmarks[System.Gadget.Settings.read("selectedBookmarkSet")] != undefined) {
			System.Gadget.settingsUI = gadgetFolderPrefix + "settings.htm";
			System.Gadget.onShowSettings = showSettingsEvent;
			System.Gadget.onSettingsClosed = procSettingsClosedEvent;
			
			checkBrowser();
			
			document.getElementById("tutorialsIcon").style.display = "none";
			if (getSetting("showTutorialIcon") != 0) {
				document.getElementById("tutorialsIcon").style.display = "block";
			}
			
			setUniqueTimer("checkForNewMessages", "checkForNewMessages()", 60000);
			
			generateGui();
			
			// first, show the gadget
			setUniqueTimer("updateTimer", "getUpdates()", 1000);
		} else {
			generateSelectBookmarkSetGui();
		}
	} catch(exception) {
		log("loadMain: " + exception.name + ", " + exception.message);
	}
}

function showSettingsEvent(event) {
	settingsOpened = true;
}

function procSettingsClosedEvent(event){
	settingsOpened = false;
	loadMain();
}

// v2

function showTutorials() {
	System.Gadget.Flyout.file = gadgetFolderPrefix + "tutorials.html";
	System.Gadget.Flyout.show = true;
	System.Gadget.Flyout.onHide = loadMain;
}

function dragNDropAdd() {
	try {
		if (System.Shell.itemFromFileDrop(event.dataTransfer, 0) != null)
		{
			var dndFile;
			for (i = 0; System.Shell.itemFromFileDrop(event.dataTransfer, i) != null; i++)
			{
				dndFile = System.Shell.itemFromFileDrop(event.dataTransfer, i).path;
				addBookmark(dndFile);
				generateGui();
			}
			saveBookmarks();
		} else if (event.dataTransfer.getData("TEXT") != "" && typeof event.dataTransfer.getData("TEXT") == "string") {
			addBookmark(event.dataTransfer.getData("TEXT"));
			generateGui();
		}
	} catch (exception) {
		log("dragNDropAdd: "+exception.name+", "+exception.message);
	}
}

function showNewMessageInfo() {
	document.getElementById("newMessageInfo").style.display = "block";
	highlightNewMessageInfo();
}

function highlightNewMessageInfo() {
	try {
		if (document.getElementById("newMessageInfo").style.display == "block") {
			if (highlightCounter < 20) {
				if (document.getElementById("newMessageInfo")) {
					if (highlightCounter % 2 == 0) {
						document.getElementById("newMessageInfo").style.left = "6";
					} else {
						document.getElementById("newMessageInfo").style.left = "4";
					}
				}
		
				setUniqueTimer("highlightNewMessageInfo", "highlightNewMessageInfo()", 50);
				highlightCounter++;
			} else {
				highlightCounter = 0;
				setUniqueTimer("highlightNewMessageInfo", "highlightNewMessageInfo()", 15000);
			}
		}
	} catch (exception) {
		log("highlightNewMessageInfo: "+exception.name+", "+exception.message);
	}
}

function showMessage() {
	try {
		
		newMessage = newMessage.replace(/{licenseKey}/g, getSetting("licenseKey"));
		newMessage = newMessage.replace(/{version}/g, versionNumber);
		splits = newMessage.split(String.fromCharCode(1));
		splits[3] = splits[3].replace(/{messageId}/g, splits[0]);
		
		document.getElementById("newMessageInfo").style.display = "none";
		
		document.body.style.height = 250 + "px";
		
		document.getElementById("newMessageDate").innerHTML = splits[1];
		document.getElementById("newMessageSubject").innerHTML = splits[2];
		document.getElementById("newMessageMessage").innerHTML = splits[3];
		document.getElementById("newMessageDiv").style.display = "block";
	} catch (exception) {
		log("showMessage: " + exception.name + ", " + exception.message);
	}
}

function closeMessage() {
	try {
		document.body.style.height = documentHeight + "px";
		
		document.getElementById("newMessageDiv").style.display = "none";
		document.getElementById("newMessageInfo").style.display = "none";
		
		setUniqueTimer("checkForNewMessages", "checkForNewMessages()", 1800000);
	} catch (exception) {
		log("closeMessage: " + exception.name + ", " + exception.message);
	}
}

function messageRead() {
	try {
		splits = newMessage.split(String.fromCharCode(1));
		openUrl(getCompletedUrl("http://www.digitaldiagnosis.de/dd_bookmarks.php?messageRead=" + splits[0]));
		closeMessage();
	} catch (exception) {
		log("messageRead: " + exception.name + ", " + exception.message);
	}
}

function checkForNewMessages() {
	try {
		XMLHttpMessages = new ActiveXObject("Microsoft.XMLHTTP");
		XMLHttpMessages.open("POST", getCompletedUrl("http://www.digitaldiagnosis.de/dd_bookmarks.php?getMessages&version="+System.Gadget.version), true);
		XMLHttpMessages.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		XMLHttpMessages.onreadystatechange=function() {
			if (XMLHttpMessages.readyState == 4)
			{
				var content = XMLHttpMessages.responseText;
				if (content.indexOf(String.fromCharCode(1)) > -1) {
					newMessage = content;
					showNewMessageInfo();
				}
			}
		}
		XMLHttpMessages.send(null);

	} catch (exception) {
		log("checkForNewMessages: " + exception.name + ", " + exception.message);
	}
}

function checkShortcutCall(shortcut, checkedKeys) {
	try {
		call = false;
		var errorCode = 1;
		if (shortcut != "") {
			errorCode = 2;
			keyCodes = shortcut.split("+");
			call = true;
			for (var j = 0; j < keyCodes.length; j++) {
				errorCode = 3;
				if (typeof (checkedKeys[keyCodes[j]]) != "undefined") {
					errorCode = 4;
					if (checkedKeys[keyCodes[j]] == false) {
						call = false;
					}
				} else {
					errorCode = 5;
					var ret = DDBookmarksAXO.isKeyPressed("caller", keyCodes[j], true);
					if (!ret) {
						checkedKeys[keyCodes[j]] = false;
						call = false;
					} else {
						checkedKeys[keyCodes[j]] = true;
					}
				}
			}
		}
		
		errorCode = 6;
		return new Array(call, checkedKeys);
	} catch (exception) {
		if (errorCode != 5) {
			log("checkShortcutCall: " + exception.name + ", " + exception.message + ", " + errorCode);
		}
		return new Array(false, checkedKeys);
	}
}

function checkShortcutCalls() {
	try {
		if (typeof DDBookmarksAXO == "undefined") {
			return;
		}
		if (getSetting("shortcutsEnabled") == 0) {
			return;
		}
		var checkedKeys = new Array();
		var shortcutDeaktivationsTmp = new Array();
		var shortcuts = new Array(getSetting("addBookmarkShortcuts"), getSetting("focusShortcuts"));
		var shortcutCommands = new Array("addBookmark", "focus");
		for (var bookmarkId in bookmarks[selectedBookmarkSet]) {
			shortcuts.push(bookmarkShortcuts[selectedBookmarkSet][bookmarkId]);
			shortcutCommands.push(bookmarkCommands[selectedBookmarkSet][bookmarkId]);
		}
		for (var i in shortcuts) {
			shortcutCodes = shortcuts[i].split(",");
			for (var j in shortcutCodes) {
				if (shortcutCodes[j] != "") {
					var ret = checkShortcutCall(shortcutCodes[j], checkedKeys);
					var call = ret[0];
					checkedKeys = ret[1];
					if (call) {
						if (shortcutDeaktivations[i] !== true) {
							shortcutDeaktivations[i] = true;
							if (shortcutCommands[i] == "focus") {
								self.focus();
							} else if (!settingsOpened) {
								if (shortcutCommands[i] == "addBookmark") {
									var newBookmark = DDBookmarksAXO.getNewBookmark();
									if ((identifyLinkType(newBookmark) == "website" || isLocalPath(newBookmark)) && lastAddedBookmark != newBookmark) {
										lastAddedBookmark = newBookmark;
										addBookmark(newBookmark);
										generateGui();
										self.focus();
									}
								} else {
									callBookmark(shortcutCommands[i], true, true);
								}
							}
						}
					} else {
						shortcutDeaktivations[i] = false;
					}
				}
			}
		}
		setUniqueTimer("checkShortcutCalls", "checkShortcutCalls()", 50);
	} catch (exception) {
		log("checkShortcutCalls: " + exception.name + ", " + exception.message + dump(ret));
	}
}

function addBookmarkBookmarks(newBookmark)
{
	try {
		var l = bookmarks[selectedBookmarkSet].length;
		bookmarks[selectedBookmarkSet][l] = newBookmark;
		bookmarkCommands[selectedBookmarkSet][l] = newBookmark;
		bookmarkIcons[selectedBookmarkSet][l] = newBookmark;
		crawlIconPathForNewBookmark(newBookmark);
	} catch (exception) {
		log("addBookmarkBookmarks: " + exception.name + ", " + exception.message);
	}
}

function keyboardInput(keyCode) {
	try {
		if (document.getElementById("bookmarksContentContainer").style.display == "block") {
			b = 0;
			if (selectedBookmark >= -1) {
				b = 1;
				add = 0;
				if (keyCode == 39) {
					add = 1;
				} else if (keyCode == 40) {
					add = getSetting("bookmarksPerLine");
				} else if (keyCode == 37) {
					add = -1;
				} else if (keyCode == 38) {
					add = -getSetting("bookmarksPerLine");
				} else if (keyCode == 13) {
					if (document.getElementById(selectedBookmark) && document.getElementById(selectedBookmark).className.match(/ selectedBookmark/)) {
						document.getElementById(selectedBookmark).onclick();
					}
				}
				add = parseInt(add);
				selectedBookmark = parseInt(selectedBookmark);
				if (add != 0) {
					if (selectedBookmark >= 0) {
						if (document.getElementById(selectedBookmark)) {
							document.getElementById(selectedBookmark).onmouseout();
							document.getElementById(selectedBookmark).className = document.getElementById(selectedBookmark).className.replace(/ selectedBookmark/, "");
						}
					}
					if (selectedBookmark < 0) {
						selectedBookmark = 0;
					} else {
						selectedBookmark = selectedBookmark + add;
					}
					if (selectedBookmark < 0) {
						selectedBookmark = 0;
					} else if (selectedBookmark >= bookmarks[selectedBookmarkSet].length) {
						selectedBookmark = bookmarks[selectedBookmarkSet].length - 1;
					}
					if (document.getElementById(selectedBookmark)) {
						document.getElementById(selectedBookmark).onmouseover();
						document.getElementById(selectedBookmark).className += " selectedBookmark";
					}
				}
			}
		}
		else if (document.getElementById("smartConnectionContainer").style.display == "block") {
			if (selectedSmartConnectionLink >= -1) {
				b = 1;
				add = 0;
				if (keyCode == 40) {
					add = 1;
				} else if (keyCode == 38) {
					add = -1;
				} else if (keyCode == 13) {
					if (document.getElementById("smartConnectionLink-" + selectedSmartConnectionLink) && document.getElementById("smartConnectionLink-" + selectedSmartConnectionLink).className.match(/ selectedSmartConnectionLink/)) {
						if (document.getElementById("smartConnectionLink-" + selectedSmartConnectionLink).getAttribute("searchTerm") == document.getElementById("smartConnectionPhrase").value) {
							document.getElementById("smartConnectionLink-" + selectedSmartConnectionLink).onclick();
						}
					}
					if (!document.getElementById("smartConnectionLink-" + selectedSmartConnectionLink) || document.getElementById("smartConnectionLink-" + selectedSmartConnectionLink).getAttribute("searchTerm") != document.getElementById("smartConnectionPhrase").value) {
						callSmartConnectionUrl(document.getElementById('smartConnectionPhrase').value);
					}
				}
				add = parseInt(add);
				selectedSmartConnectionLink = parseInt(selectedSmartConnectionLink);
				if (add != 0) {
					if (selectedSmartConnectionLink > 0) {
						document.getElementById("smartConnectionLink-" + selectedSmartConnectionLink).className = document.getElementById("smartConnectionLink-" + selectedSmartConnectionLink).className.replace(/ selectedSmartConnectionLink/, "");
					}
					selectedSmartConnectionLink = selectedSmartConnectionLink + add;
					if (selectedSmartConnectionLink < 1) {
						selectedSmartConnectionLink = 0;
						document.getElementById("smartConnectionPhrase").focus();
					} else if (selectedSmartConnectionLink >= parseInt(document.getElementById("smartConnectionMax").innerHTML)) {
						selectedSmartConnectionLink = parseInt(document.getElementById("smartConnectionMax").innerHTML);
					}
					if (document.getElementById("smartConnectionLink-" + selectedSmartConnectionLink)) {
						document.getElementById("smartConnectionLink-" + selectedSmartConnectionLink).className += " selectedSmartConnectionLink";
						smartConnectionPhrase.blur();
					}
				}
			}
		}
	} catch (exception) {
		log("keyboardInput: " + exception.name + ", " + exception.message + "," + selectedSmartConnectionLink);
	}
}

function toggleDivider(dividerId) {
	if (bookmarkIcons[selectedBookmarkSet][dividerId] == 0) {
		bookmarkIcons[selectedBookmarkSet][dividerId] = 1;
	} else {
		bookmarkIcons[selectedBookmarkSet][dividerId] = 0;
	}
	saveBookmarks();
}

function toggleDividerImage(dividerId, active) {
	if (bookmarkIcons[selectedBookmarkSet][dividerId] == 0) {
		if (active) {
			fileName = "dividerClosedActive";
		} else {
			fileName = "dividerClosed";
		}
	} else {
		if (active) {
			fileName = "dividerActive";
		} else {
			fileName = "divider";
		}
	}
	
	document.getElementById("dividerLabel-" + dividerId).style.backgroundImage = "url(images/" + fileName + ".png)";
	document.getElementById("dividerLabel-" + dividerId).title = fileName;
}

function generateGui()
{
	try {
		document.getElementById("bookmarksContentContainer").style.display = "block";
		document.getElementById("selectBookmarkSetContainer").style.display = "none";
		document.getElementById("smartConnectionContainer").style.display = "none";
		selectedBookmark = -1;
		bookmarksPerLine = getSetting("bookmarksPerLine");
		document.getElementById("info").style.color = "#" + getSetting("infoFontColor");
		document.getElementById("bookmarksDiv").innerHTML = "";
		segmentPos = 0;
		rows = 0;
		for (i = 0; i < bookmarks[selectedBookmarkSet].length; i++) {
			segmentPos++;
			if (bookmarks[selectedBookmarkSet][i].substr(0, 1) === String.fromCharCode(2)) {
				segmentPos = 0;
				rows++;
			} else {
				if ((segmentPos - 1) % bookmarksPerLine == 0) {
					rows++;
				} else {
				}
			}
		}
//		rows = Math.ceil(bookmarks[selectedBookmarkSet].length / bookmarksPerLine);
		if (bookmarksPerLine == 3) {
			positionClasses = new Array(new Array("left_top_button", "center_top_button", "right_top_button"), new Array("left_middle_button", "center_middle_button", "right_middle_button"), new Array("left_bottom_button", "center_bottom_button", "right_bottom_button"));
		} else {
			positionClasses = new Array(new Array("left_top_button", "center_top_button", "center_top_button", "right_top_button"), new Array("left_middle_button", "center_middle_button", "center_middle_button", "right_middle_button"), new Array("left_bottom_button", "center_bottom_button", "center_bottom_button", "right_bottom_button"));
		}
		if (bookmarksPerLine == 6) {
			bookmarkSize = 20;
		} else if (bookmarksPerLine == 5) {
			bookmarkSize = 24;
		} else {
			bookmarkSize = 32;
		}
		segmentPos = 0;
		rowsCounter = 0;
		dividerCounter = 0;
		visibleBookmark = true;
		parentObj = document.getElementById("bookmarksDiv");
		for (i = 0; i < bookmarks[selectedBookmarkSet].length; i++)
		{
			segmentPos++;
			if (bookmarks[selectedBookmarkSet][i].substr(0, 1) === String.fromCharCode(2)) {
				segmentPos = 0;
				rowsCounter++;
				dividerCounter++;
				dividerDiv = document.createElement("div");
				dividerDiv.id = "divider-" + i;
				dividerLabelDiv = document.createElement("div");
				dividerLabelDiv.innerHTML = bookmarks[selectedBookmarkSet][i].substr(1);
				dividerLabelDiv.className = "dividerLabel";
				dividerLabelDiv.style.color = "#" + getSetting("infoFontColor");
				dividerLabelDiv.style.backgroundImage = "url(images/divider.png)";
				dividerLabelDiv.onmouseover = function() {toggleDividerImage(this.alt, true);}
				dividerLabelDiv.onmouseout = function() {toggleDividerImage(this.alt, false);}
				dividerLabelDiv.onclick = function() {toggleDivider(this.alt);generateGui();}
				dividerLabelDiv.alt = i;
				dividerLabelDiv.style.backgroundRepeat = "no-repeat";
				dividerLabelDiv.style.backgroundPosition = "3px 0px";
				dividerLabelDiv.id = "dividerLabel-" + i;
				dividerDiv.appendChild(dividerLabelDiv);
				dividerContent = document.createElement("div");
				visibleBookmark = true;
				if (bookmarkIcons[selectedBookmarkSet][i] == 0) {
					dividerContent.style.display = "none";
					visibleBookmark = false;
				}
				dividerContent.title = "jdsf" + bookmarkIcons[selectedBookmarkSet][i];
				dividerContent.id = "dividerContent-" + i;
				dividerDiv.appendChild(dividerContent);
				document.getElementById("bookmarksDiv").appendChild(dividerDiv);
				toggleDividerImage(i, false);
				parentObj = dividerContent;
			} else {
				bookmarkCol = ((segmentPos - 1) % bookmarksPerLine);
				bookmarkRow = Math.floor(i / bookmarksPerLine);
				if (bookmarkCol == 0) {
					bookmarkClass = "left_";
					if (visibleBookmark) {
						rowsCounter++;
					}
				} else if (bookmarkCol == (bookmarksPerLine - 1)) {
					bookmarkClass = "right_";
				} else {
					bookmarkClass = "center_";
				}
				if (rowsCounter == 1) {
					bookmarkClass += "top_button";
				} else if (rows == rowsCounter) {
					bookmarkClass += "bottom_button";
				} else {
					bookmarkClass += "middle_button";
				}
				bookmarkDiv = document.createElement("div");
				bookmarkImg = document.createElement("img");
				bookmarkImg.src = imageSrc(bookmarkIcons[selectedBookmarkSet][i], bookmarkSize);
				bookmarkImg.width = bookmarkSize;
				bookmarkImg.height = bookmarkSize;
				bookmarkImg.title = basename(bookmarks[selectedBookmarkSet][i]);
				bookmarkImg.alt= bookmarks[selectedBookmarkSet][i];
				bookmarkImg.id = "bI-"+i;
				bookmarkImg.className = "bookmarkImg";
				bookmarkDiv.appendChild(bookmarkImg);
				bookmarkDiv.id = i;
				bookmarkDiv.onmouseover = function(e){ document.getElementById("info").innerHTML=getInfoLabel(this.id);selectedBookmark=this.id;this.style.border="0px";this.style.paddingTop='1px';this.style.paddingBottom='0px';this.style.paddingLeft='1px';this.style.paddingRight='0px'; }
				bookmarkDiv.onmouseout = function(e){ document.getElementById("info").innerHTML="";this.style.paddingTop='0px';this.style.paddingBottom='1px';this.style.paddingLeft='0px';this.style.paddingRight='1px'; }
				bookmarkDiv.onclick = function(e) { selectedBookmark=-1;lastCalledBookmarkId = this.id;if(intelligentDialogs[selectedBookmarkSet][this.id]==0){callBookmark(getBookmarkCommand(this.id), true, true);}else{callBookmark(getBookmarkCommand(this.id), true);} }
				bookmarkDiv.ondblclick = function(e) { return; lastOnDblClick = new Date().getTime();showFastBrowser(getBookmarkCommand(this.id)); }
				bookmarkDiv.className = bookmarkClass;
				bookmarkDiv.style.width = bookmarkSize;
				bookmarkDiv.title = bookmarks[selectedBookmarkSet][i];
				bookmarkDiv.alt = bookmarks[selectedBookmarkSet][i];
				parentObj.appendChild(bookmarkDiv);
			}
		}
		
		document.body.style.backgroundImage = "url("+getBackgroundPath(getSetting("backgroundImage"))+")";
		document.body.style.backgroundRepeat = "repeat";
		
		documentHeight = ((rowsCounter - dividerCounter) * (bookmarkSize + 1) + dividerCounter * 14 + 12 + 14);
		document.body.style.height = documentHeight + "px";
	} catch(exception) {
		log("generateGui: "+exception.name+", "+exception.message);
	}
}

function generateSelectBookmarkSetGui() {
	try {
		document.getElementById("bookmarksContentContainer").style.display = "none";
		document.getElementById("selectBookmarkSetContainer").style.display = "block";
		document.getElementById("smartConnectionContainer").style.display = "none";
		selectedBookmark = -2;
		selectedSmartConnectionLink = 0;
		counter = 0;
		for (var bookmarkSet in bookmarks) {
			counter++;
			div = document.createElement("div");
			div.innerHTML = bookmarkSetNames[bookmarkSet] + "<br>";
			div.style.border = "2px solid #FFF";
			div.style.fontSize = "9pt";
			div.style.fontWeight = "bold";
			div.alt = bookmarkSet;
			div.style.cursor = "pointer";
			div.onclick = function (e) {
				selectBookmarkSet(this.alt);
			}
			div.onmouseover = function (e) {
				this.style.border = "2px solid #CCC";
				this.style.backgroundColor = "#EEE";
			}
			div.onmouseout = function (e) {
				this.style.border = "2px solid #FFF";
				this.style.backgroundColor = "transparent";
			}
			for (var i = 0; i < bookmarks[bookmarkSet].length; i++) {
				img = document.createElement("img");
				img.src = imageSrc(bookmarkIcons[bookmarkSet][i], 24);
				img.style.width = 24;
				img.style.height = 24;
				img.width = 24;
				img.height = 24;
				img.alt = bookmarkSet;
				img.style.cursor = "pointer";
				img.onclick = function (e) {
					selectBookmarkSet(this.alt);
				}
				img.title = basename(bookmarks[bookmarkSet][i]);
				div.appendChild(img);
				if (i >= 4) {
					div.innerHTML += "&nbsp;..";
					break;
				}
			}
			document.getElementById("selectBookmarkSetContainer").appendChild(div);
		}
		
		document.body.style.backgroundImage = "url("+getBackgroundPath(getSetting("backgroundImage"))+")";
		document.body.style.backgroundRepeat = "repeat";

		
		documentHeight = (counter * (43) + 6);
		document.body.style.height = documentHeight + "px";
	} catch(exception) {
		log("generateSelectBookmarkSetGui: "+exception.name+", "+exception.message);
	}
}

function generateSmartConnectionGui() {
	try {
		document.getElementById("bookmarksContentContainer").style.display = "none";
		document.getElementById("selectBookmarkSetContainer").style.display = "none";
		document.getElementById("smartConnectionContainer").style.display = "block";
		
		document.getElementById("bookmarkSmartConnectionUrlsContent").style.display = "none";
		document.getElementById("smartConnectionGoogleSearch").style.display = "none";
		
		selectedBookmark = -2;
		selectedSmartConnectionLink = 0;
		document.getElementById("lastSmartConnectionPhrase").innerHTML = "";
		
		document.body.style.backgroundImage = "url("+getBackgroundPath(getSetting("backgroundImage"))+")";
		document.body.style.backgroundRepeat = "repeat";

		document.getElementById("smartConnectionPhrase").focus();
		
		if (getSetting("showSmartConnectionInfo") != 0) {
			if (documentHeight < 190) {
				documentHeight = 190;
			}
		} else {
			documentHeight = 60;
		}
		documentHeight = documentHeight;
		document.body.style.height = documentHeight + "px";
		
		document.getElementById("smartConnectionInfo").style.display = "none";
		if (getSetting("showSmartConnectionInfo") != 0) {
			document.getElementById("smartConnectionInfo").style.display = "block";
		} else {
			document.getElementById("smartConnectionInfo").style.display = "none";
		}
	} catch(exception) {
		log("generateSelectBookmarkSetGui: "+exception.name+", "+exception.message);
	}
}

function selectBookmarkSet(bookmarkSet) {
	try {
		selectedBookmarkSet = bookmarkSet;
		System.Gadget.Settings.write("selectedBookmarkSet", selectedBookmarkSet);
		
		loadMain();
	} catch(exception) {
		log("selectBookmarkSet: " + exception.name + ", " + exception.message);
	}
}

function getBookmarkCommand(id)
{
	return bookmarkCommands[selectedBookmarkSet][id];
}

function getInfoLabel(id)
{
	return bookmarkLabels[selectedBookmarkSet][id];
}

function checkBrowser()
{
	try {
		browserPath = getSetting("browserPath");
		if (typeof browserPath != 'undefined' && (oFSO.FileExists(browserPath) || browserPath == ""))
		{
			return browserPath;
		}
		else
		{
			System.Gadget.Flyout.file = gadgetFolderPrefix + "selectBrowser.html";
			System.Gadget.Flyout.show = true;
			System.Gadget.Flyout.onHide = loadMain;
		}
	} catch (exception) {
		log("getBrowserPath: "+exception.name+", "+exception.message);
	}
}

function showVersionNotification()
{
}
	
function log(message, append){addError(message);}