/**************************************************
 * general.js
 * November 2009
 * digitaldiagnosis
***************************************************/

var settingsDir;
var bookmarksFile;
var searchHistoryFile;
var defaultBookmarks;
var defaultBookmarkCommands;
var initBookmarks;
var initBookmarkIcons;
var bookmarks = "";
var bookmarkCommands = "";
var bookmarkLabels = "";
var bookmarkIcons = "";
var searchHistory = "";
var bookmarkShortcuts = "";
var lastCalledBookmarkId;
var intelligentDialogs = "";
var intelligentDialogContents = "";
var intelligentDialogInfos = "";
var settings;
var settingsFile;
var oShell;
var oFSO;
var versionNumber;
var downloadLink;
var isd = "";
var bookmarkHashs = new Array();
var networkInUse = false;
var XMLHttp2GetHashs;
var gadgetFolderPrefix;
var lastOnDblClick = 0;
var lastServerOnlineCheck = 0;
var serverOnlineCheck;
var lastServer2OnlineCheck = 0;
var server2OnlineCheck;
var l;
var selectedBookmarkSet;
var bookmarkSetNames = new Array();
var theme;
var DDBookmarksAXO;
var shortcutDeaktivations = new Array();
var settingsOpened = false;
var timers = new Array();
var lastAddedBookmark;


function init()
{
	try {
		gadgetFolderPrefix = "v" + System.Gadget.version + "\\";
		var splits = System.Gadget.version.split(".");
		if (splits[1].length == 1)
			splits[1] = "0"+splits[1];
		if (splits[2].length == 1)
			splits[2] = "0"+splits[2];
		versionNumber = splits.join("");
		downloadLink = "www.digitaldiagnosis.de/dd_bookmarks.php";
		
		theme = "";

		oShell = new ActiveXObject("WScript.Shell");
		oFSO = new ActiveXObject("Scripting.FileSystemObject");
		
		if (theme == "") {
			System.Gadget.Settings.write("settingsPath", oShell.SpecialFolders("Appdata") + "\\dd_bookmarks");
		} else {
			System.Gadget.Settings.write("settingsPath", oShell.SpecialFolders("Appdata") + "\\dd_bookmarks\\" + theme);
			
			var folder = "";
			splits = (System.Gadget.Settings.read("settingsPath")).split("\\");
			for (var i = 0; i < (splits.length - 1); i++) {
				folder += splits[i] + "\\";
				if (oFSO.FolderExists(folder) === false) {
					oFSO.CreateFolder(folder);
				}
			}
		}
		
		defaultBookmarks = new Array("amazon","bing","blogger","booking","cnn","craigslist","ebay","expedia","facebook","flickr","google","msn","myspace","netflix","twitter","weather.com","wikipedia","yahoo","youtube","Text-Editor","Control Panel","Calculator","Recycle Bin","Explorer","TaskManager","Update","Shutdown","Restart","Lock","Standby","Logout","SmartConnection");
		defaultBookmarkCommands = new Array("http://www.amazon.com/","http://www.bing.com/","http://www.blogger.com/","http://www.booking.com/","http://www.cnn.com/","http://www.craigslist.org/","http://www.ebay.com/","http://www.expedia.com/","http://www.facebook.com/","http://www.flickr.com/","http://www.google.com/","http://www.msn.com/","http://www.myspace.com/","http://www.netflix.com/","http://www.twitter.com/","http://www.weather.com/","http://wikipedia.org/","http://www.yahoo.com/","http://www.youtube.com/","%windir%\\system32\\notepad.exe","control","calc","::{645FF040-5081-101B-9F08-00AA002F954E}","::{20D04FE0-3AEA-1069-A2D8-08002B30309D}","taskmgr","http://www.digitaldiagnosis.de/dd_bookmarks.php","shutdown /p /f","shutdown /g /t 00","rundll32.exe user32.dll,LockWorkStation","rundll32.exe powrprof.dll,SetSuspendState","shutdown /l","smartconnection");
		
		initBookmarks = new Array("SmartConnection","Explorer","google","youtube","wikipedia","Calculator","amazon","facebook");
		initBookmarkIcons = new Array("SmartConnection.png","Explorer.png","google.png","youtube.png","wikipedia.png","Calculator.png","amazon.png","facebook.png");

		bookmarksFile = System.Gadget.Settings.read("settingsPath") + "\\bookmarks.txt";
		settingsFile = System.Gadget.Settings.read("settingsPath") + "\\settings.txt";
		searchHistoryFile = System.Gadget.Settings.read("settingsPath") + "\\searchHistory.txt";
		errorFile = System.Gadget.Settings.read("settingsPath") + "\\errors.txt";

		folderPath = System.Gadget.path + "\\general\\images\\backgrounds\\";
		var folder = "";
		splits = (folderPath).split("\\");
		for (var i = 0; i < (splits.length - 1); i++) {
			folder += splits[i] + "\\";
			if (oFSO.FolderExists(folder) === false) {
				oFSO.CreateFolder(folder);
			}
		}

		folderPath = System.Gadget.Settings.read("settingsPath") + "\\dll\\";
		var folder = "";
		splits = (folderPath).split("\\");
		for (var i = 0; i < (splits.length - 1); i++) {
			folder += splits[i] + "\\";
			if (oFSO.FolderExists(folder) === false) {
				oFSO.CreateFolder(folder);
			}
		}
		
		loadSettings();
		
		l = new Language("en");
		setLanguage();
		
		registerDlls();
		
		loadBookmarks();
		
		initVersion();
		
		sendErrors();

		if (getSetting("licenseKey") == null) {
			getLicenseKey();
		}
		
	} catch (exception) {
		log("init: "+exception.name+", "+exception.message);
	}
}

function initVersion() {
	try {
		if (typeof getSetting("downloadedVersion") == "undefined") {
			setSetting("downloadedVersion", System.Gadget.version);
		}
		if (getSetting("lastInitVersion") != System.Gadget.version) {
			if (System.Gadget.version == "2.4.0") {
//				for (var bookmarkSet in bookmarks) {
//					for (var bookmarkInd in bookmarks[bookmarkSet]) {
//						bookmarkCommands[bookmarkSet][bookmarkInd] = bookmarks[bookmarkSet][bookmarkInd];
//						bookmarkLabels[bookmarkSet][bookmarkInd] = getInfoName(bookmarks[bookmarkSet][bookmarkInd]);
//					}
//				}
//				saveBookmarks();
			}
			setSetting("lastInitVersion", System.Gadget.version);
		}
	} catch (exception) {
		log("initVersion: "+exception.name+", "+exception.message);
	}
}

function registerDlls() {
	var dlls = [ [ "{4b8de90f-3ee0-40b5-921d-b13785eebd29}", "DigitalDiagnosis.DDBookmarks", "DigitalDiagnosis.DDBookmarks.dll" ] ];
	try {
		for (var i = 0; i < dlls.length; i++) {
			var dll = dlls[i];
			var dllOriginPath = System.Gadget.path + "\\" + gadgetFolderPrefix + "dll\\" + dll[2];
			var dllPath = System.Gadget.Settings.read("settingsPath") + "\\dll\\" + System.Gadget.version + "_" + dll[2];

			dllFile = oFSO.getFile(dllOriginPath);
			try {
				dllFile.copy(dllPath);
			} catch (e) {
			}
			
			oShell.RegWrite("HKCU\\Software\\Classes\\", dll[1]);
			oShell.RegWrite("HKCU\\Software\\Classes\\" + dll[1] + "\\",
					dll[1]);
			oShell.RegWrite(
					"HKCU\\Software\\Classes\\" + dll[1] + "\\CLSID\\", dll[0]);
			oShell.RegWrite("HKCU\\Software\\Classes\\CLSID\\" + dll[0] + "\\",
					dll[1]);

			oShell.RegWrite("HKCU\\Software\\Classes\\CLSID\\" + dll[0]
					+ "\\InprocServer32\\", "mscoree.dll");
			oShell.RegWrite("HKCU\\Software\\Classes\\CLSID\\" + dll[0]
					+ "\\InprocServer32\\ThreadingModel", "Both");
			oShell.RegWrite("HKCU\\Software\\Classes\\CLSID\\" + dll[0]
					+ "\\InprocServer32\\Class", dll[1]);
			oShell.RegWrite("HKCU\\Software\\Classes\\CLSID\\" + dll[0]
					+ "\\InprocServer32\\Assembly", dll[1]
					+ ", Version=1.0.0.0, Culture=neutral, PublicKeyToken=null");
			oShell.RegWrite("HKCU\\Software\\Classes\\CLSID\\" + dll[0]
					+ "\\InprocServer32\\RuntimeVersion", "v2.0.50727");
			oShell.RegWrite("HKCU\\Software\\Classes\\CLSID\\" + dll[0]
					+ "\\InprocServer32\\CodeBase", dllPath);

			oShell.RegWrite("HKCU\\Software\\Classes\\CLSID\\" + dll[0]
					+ "\\InprocServer32\\1.0.0.0\\Class", dll[1]);
			oShell.RegWrite("HKCU\\Software\\Classes\\CLSID\\" + dll[0]
					+ "\\InprocServer32\\1.0.0.0\\Assembly", dll[1]
					+ ", Version=1.0.0.0, Culture=neutral, PublicKeyToken=null");
			oShell.RegWrite("HKCU\\Software\\Classes\\CLSID\\" + dll[0]
					+ "\\InprocServer32\\1.0.0.0\\RuntimeVersion", "v2.0.50727");
			oShell.RegWrite("HKCU\\Software\\Classes\\CLSID\\" + dll[0]
					+ "\\InprocServer32\\1.0.0.0\\CodeBase", dllPath);

			oShell.RegWrite("HKCU\\Software\\Classes\\CLSID\\" + dll[0]
					+ "\\dll[1]\\", dll[1]);

			oShell
					.RegWrite(
							"HKCU\\Software\\Classes\\CLSID\\"
									+ dll[0]
									+ "\\Implemented Categories\\{62C8FE65-4EBB-45E7-B440-6E39B2CDBF29}\\",
							"");
			try {
				new ActiveXObject(dll[1]);
			} catch (e) {
				log("dll-error: " + dll[1]);
				document.getElementById("info").innerHTML = l.get("dllError");
			}
		}
		try {
			var dllName = "DigitalDiagnosis.DDBookmarks";
			DDBookmarksAXO = new ActiveXObject(dllName);
			try {
				if (DDBookmarksAXO.getVersion() >= 101) {
				}
				setSetting("dllVersion", DDBookmarksAXO.getVersion());
			} catch (e) {
				DDBookmarksAXO.getNewBookmark();
				setSetting("dllVersion", "100");
			}
		} catch (e) {
			log("dll-error2: " + dllName);
			document.getElementById("info").innerHTML = l.get("dllError");
		}
	} catch (exception) {
		log("registerDlls: "+exception.name+", "+exception.message);
	}
}

function loadBookmarks()
{
	try {
		if (System.Gadget.Settings.read("selectedBookmarkSet") != undefined) {
			selectedBookmarkSet = System.Gadget.Settings.read("selectedBookmarkSet");
		}
		bookmarks = new Array();
		bookmarkCommands = new Array();
		bookmarkLabels = new Array();
		bookmarkIcons = new Array();
		bookmarkShortcuts = new Array();
		intelligentDialogs = new Array();
		if (intelligentDialogContents == "") {
			intelligentDialogContents = new Array();
		}
		searchHistory = new Array();
		var bookmarkSet = undefined;
		if (!oFSO.FolderExists(System.Gadget.Settings.read("settingsPath")) || !oFSO.FileExists(bookmarksFile))
		{
			if (!oFSO.FolderExists(System.Gadget.Settings.read("settingsPath")))
			{
				oFSO.CreateFolder(System.Gadget.Settings.read("settingsPath"));
			}

			selectedBookmarkSet = 1;
			System.Gadget.Settings.write("selectedBookmarkSet", selectedBookmarkSet);
			bookmarks[selectedBookmarkSet] = new Array();
			bookmarkCommands[selectedBookmarkSet] = new Array();
			bookmarkLabels[selectedBookmarkSet] = new Array();
			bookmarkSetNames[selectedBookmarkSet] = l.get("bookmarkSetDefaultName") + "-1";
			bookmarkIcons[selectedBookmarkSet] = new Array();
			bookmarkShortcuts[selectedBookmarkSet] = new Array();
			intelligentDialogs[selectedBookmarkSet] = new Array();
			intelligentDialogContents[selectedBookmarkSet] = new Array();
			searchHistory[selectedBookmarkSet] = new Array();
			for (i = 0; i < initBookmarks.length; i++)
			{
				bookmarks[selectedBookmarkSet][i] = getDefaultBookmarkCommand(initBookmarks[i]);
				bookmarkCommands[selectedBookmarkSet][i] = getDefaultBookmarkCommand(initBookmarks[i]);
//				for (j = 0; j < defaultBookmarks.length; j++)
//				{
//					if (defaultBookmarks[j] == initBookmarks[i]) {
//						bookmarkCommands[selectedBookmarkSet][i] = defaultBookmarkCommands[j];
//					}
//				}
				bookmarkLabels[selectedBookmarkSet][i] = initBookmarks[i];
				bookmarkIcons[selectedBookmarkSet][i] = "+++GADGETPATH+++" + "\\images\\" + initBookmarkIcons[i];
				bookmarkShortcuts[selectedBookmarkSet][i] = "";
				intelligentDialogs[selectedBookmarkSet][i] = 1;
				searchHistory[selectedBookmarkSet][i] = new Array();
			}
			saveBookmarks();
		}
		else
		{
//			var sFile = oFSO.OpenTextFile(bookmarksFile, 1);
			var lines = readTextFile(bookmarksFile);
			i = 0;
			for (var lineInd = 0; lineInd < lines.length; lineInd++)
//		    for (var i = 0; !sFile.AtEndOfStream; i++)
		    {
		    	var line = lines[lineInd];
		    	if (line.substr(0, 1) == String.fromCharCode(1)) {
		    		splits = line.substr(1, line.length - 1).split(String.fromCharCode(0));
		    		bookmarkSet = splits[0];
		    		bookmarks[bookmarkSet] = new Array();
		    		bookmarkCommands[bookmarkSet] = new Array();
		    		bookmarkLabels[bookmarkSet] = new Array();
		    		bookmarkSetNames[bookmarkSet] = splits[1];
		    		bookmarkIcons[bookmarkSet] = new Array();
		    		bookmarkShortcuts[bookmarkSet] = new Array();
					intelligentDialogs[bookmarkSet] = new Array();
					searchHistory[bookmarkSet] = new Array();
					if (String(selectedBookmarkSet).length == 0) {
						selectedBookmarkSet = bookmarkSet;
					}
					i = -1;
		    	} else {
		    		if (bookmarkSet == undefined) {
		    			selectedBookmarkSet = 1;
		    			System.Gadget.Settings.write("selectedBookmarkSet", selectedBookmarkSet);
		    			bookmarkSet = 1;
		    			bookmarks[bookmarkSet] = new Array();
		    			bookmarkCommands[bookmarkSet] = Array();
		    			bookmarkLabels[bookmarkSet] = new Array();
		    			bookmarkSetNames[bookmarkSet] = l.get("bookmarkSetDefaultName") + "-1";
			    		bookmarkIcons[bookmarkSet] = new Array();
			    		bookmarkShortcuts[bookmarkSet] = new Array();
						intelligentDialogs[bookmarkSet] = new Array();
						searchHistory[bookmarkSet] = new Array();
						i = 0;
		    		}
		    		if (selectedBookmarkSet == "") {
		    			selectedBookmarkSet = bookmarkSet;
		    		}
		    		// can be removed for future versions
		    		if (System.Gadget.version == "2.4.0" && line.search(String.fromCharCode(0)) != -1) {
		    			splits = line.split(String.fromCharCode(0));
		    		} else {
		    			splits = line.split(String.fromCharCode(1));
		    		}
		    		if (System.Gadget.version == "2.4.0" && line.search(String.fromCharCode(0)) != -1) {
		    			var bookmark = splits[0];
		    			if (getDefaultBookmarkCommand(bookmark) != null) {
		    				bookmark = getDefaultBookmarkCommand(bookmark);
		    			}
						var bookmarkCommand = bookmark;
		    			var bookmarkLabel = getInfoName(splits[0]);
		    			var intelligentD = splits[2];
		    			var bookmarkIcon = splits[1];
		    		} else {
		    			var bookmark = splits[0];
		    			var bookmarkCommand = splits[1];
		    			var bookmarkLabel = splits[2];
		    			var intelligentD = splits[5];
		    			var bookmarkIcon = splits[6];
		    		}
		    		bookmarks[bookmarkSet][i] = bookmark;
			    	bookmarkCommands[bookmarkSet][i] = bookmarkCommand;
			    	bookmarkLabels[bookmarkSet][i] = bookmarkLabel;
			    	var srcPath = bookmarkIcon.replace("+++GADGETPATH+++", System.Gadget.path);
			    	if (bookmarkIcon != "" && !oFSO.FileExists(srcPath)) {
			    		if (oFSO.FileExists(srcPath.replace(System.Gadget.path + "\\", System.Gadget.path + "\\" + gadgetFolderPrefix))) {
			    			srcPath = srcPath.replace(System.Gadget.path + "\\", System.Gadget.path + "\\" + gadgetFolderPrefix);
			    		}
			    	}
			    	if (bookmarkIcon != "" && (oFSO.FileExists(srcPath) || oFSO.FolderExists(srcPath)) || isDefaultBookmark(bookmarkCommands[bookmarkSet][i]) || identifyLinkType(splits[0], true) == "divider")
			    	{
			    		bookmarkIcons[bookmarkSet][i] = bookmarkIcon;
			    	}
			    	else
			    	{
			    		if (identifyLinkType(bookmarkIcon, true) == "website")
			    		{
			    			bookmarkIcons[bookmarkSet][i] = "/images/www.png"
			    		}
			    		else
			    		{
			    			bookmarkIcons[bookmarkSet][i] = "/images/0.png";
			    		}
			    	}
			    	if (splits.length > 4 && splits[4] != "undefined") {
			    		bookmarkShortcuts[bookmarkSet][i] = splits[4];
			    	} else {
			    		bookmarkShortcuts[bookmarkSet][i] = "";
			    	}
			    	intelligentDialogs[bookmarkSet][i] = intelligentD;
			    	if (typeof splits[3] != "undefined")
			    	{
			    		searchHistory[bookmarkSet][i] = splits[3].split(String.fromCharCode(1));
			    	}
			    	else
			    	{
			    		searchHistory[bookmarkSet][i] = new Array();
			    	}
		    	}
		    	i++;
		    }
		}
		for (var bookmarkSet2 in bookmarks) {
			for (j = 0; j < bookmarks[bookmarkSet2].length; j++) {
				bookmarks[bookmarkSet2][j] = bookmarks[bookmarkSet2][j].replace(/\\\\/g, "\\").replace(/\\/g, "\\\\");
				bookmarkCommands[bookmarkSet2][j] = bookmarkCommands[bookmarkSet2][j].replace(/\\\\/g, "\\").replace(/\\/g, "\\\\");
			}
		}
	} catch (exception) {
		log("loadBookmarks: "+exception.name+", "+exception.message);
	}
}

function callSmartConnectionUrl(url, linkId) {
	try {
		if (isLocalPath(url))
		{
			if (url.indexOf("shutdown ") > -1) {
				oShell.Exec(url);
			} else {
				System.Shell.execute(url);
			}
			return true;
		} else if (url != "") {
			document.getElementById('smartConnectionLoaderbar').style.display = "block";
			if (getSetting("smartConnectionDirectCall") == 1 || typeof(linkId) != "undefined") {
				serverUrl = "1http://redirect.digitaldiagnosis.de/?bookmarks&p="+(parseInt(linkId) + 1)+"&smartconnection-" + escape(url);
				if (!serverOnline() && server2Online()) {
					serverUrl = "1http://redirect.dd.computer-specialist.eu/?bookmarks&p="+(parseInt(linkId) + 1)+"&smartconnection-" + escape(url);
				}
				serverUrl = getCompletedUrl(serverUrl);
				
				if ((typeof getSetting("browserPath") == "undefined" || getSetting("browserPath") == ""))
				{
					if (serverUrl.substr(0, 1) == "1") {
						window.open(serverUrl.substr(1, serverUrl.length - 1));
					}
				}
				else
				{
					if (serverUrl.substr(0, 1) == "1") {
						System.Shell.execute(getSetting("browserPath").replace(/\\\\/g, "\\").replace(/\\/g, "\\\\"), serverUrl.substr(1, serverUrl.length - 1));
					}
				}
				document.getElementById('smartConnectionLoaderbar').style.display = "none";
			} else if (document.getElementById("lastSmartConnectionPhrase").innerHTML != url) {
				serverUrl = "1http://redirect.digitaldiagnosis.de/?bookmarks&smartconnection-" + escape(url);
				if (!serverOnline() && server2Online()) {
					serverUrl = "1http://redirect.dd.computer-specialist.eu/?bookmarks&smartconnection-" + escape(url);
				}
				serverUrl = getCompletedUrl(serverUrl);
				document.getElementById("bookmarkSmartConnectionUrlsContent").innerHTML = "";
				
				XMLHttp2GetSmartConnectionUrls = new ActiveXObject("Microsoft.XMLHTTP");
				XMLHttp2GetSmartConnectionUrls.open("POST", serverUrl.substr(1, serverUrl.length - 1), true);
				XMLHttp2GetSmartConnectionUrls.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
				XMLHttp2GetSmartConnectionUrls.onreadystatechange=function() {
					if (XMLHttp2GetSmartConnectionUrls.readyState == 4)
					{
						document.getElementById('smartConnectionLoaderbar').style.display = "none";
						var content = XMLHttp2GetSmartConnectionUrls.ResponseText;
						var splits = content.split(String.fromCharCode(1));
						for (var linkId = 0; linkId < splits.length; linkId++) {
							if (splits[linkId].substr(0, 7) == "http://" || splits[linkId].substr(0, 8) == "https://" || splits[linkId].substr(0, 6) == "ftp://") {
								urlDiv = document.createElement("div");
								urlDiv.className = "smartConnectionLinkDiv";
								urlImg = document.createElement("img");
								urlImg.title = l.get("bookmark") + " '" + splits[linkId] + "'";
								urlImg.src = "images/bookmark.png";
								urlImg.id = "bookmarkSmartConnectionUrl";
								urlImg.alt = splits[linkId];
								urlImg.className = "smartConnectionImage";
								urlImg.onclick = function() {
									addBookmark(this.alt);
								}
								textDiv = document.createElement("div");
								textDiv.innerHTML = splits[linkId].replace("http://", "").replace("https://", "").replace("www.", "");
								textDiv.title = splits[linkId];
								textDiv.alt = splits[linkId];
								textDiv.id = "smartConnectionLink-" + (linkId + 1);
								textDiv.setAttribute("searchTerm", url);
								textDiv.setAttribute("position", linkId);
								textDiv.className = "smartConnectionLink";
								if (linkId == 0) {
									textDiv.className += " selectedSmartConnectionLink";
								}
								textDiv.onclick = function() {
									callSmartConnectionUrl(this.getAttribute('searchTerm'), this.getAttribute('position'));
								}
								urlDiv.appendChild(urlImg);
								urlDiv.appendChild(textDiv);
								document.getElementById("bookmarkSmartConnectionUrlsContent").appendChild(urlDiv);
							} else {
								textDiv = document.createElement("div");
								textDiv.innerHTML = l.get("smartConnectionNoResults");
								textDiv.style.fontWeight = "bold";
								textDiv.style.textAlign = "center";
								document.getElementById("bookmarkSmartConnectionUrlsContent").appendChild(textDiv);
							}
						}
						maxDiv = document.createElement("div");
						maxDiv.style.display = "none";
						maxDiv.innerHTML = splits.length;
						maxDiv.id = "smartConnectionMax";
						document.getElementById("lastSmartConnectionPhrase").innerHTML = url;
						document.getElementById("bookmarkSmartConnectionUrlsContent").appendChild(maxDiv);
						document.getElementById("bookmarkSmartConnectionUrlsContent").style.display = "block";
						document.getElementById("smartConnectionGoogleSearch").style.display = "block";
						document.body.style.height = documentHeight + 14 * splits.length;
						selectedSmartConnectionLink = 1;
					}
				}
				XMLHttp2GetSmartConnectionUrls.send("getUrls=1");
			}
		}
	} catch (exception) {
		log("callSmartConnectionUrl: " + exception.name + ", " + exception.message);
	}
}

function indicateCall(url) {
	try {
		indicateUrl = "http://www.digitaldiagnosis.de/dd_bookmarks/indicate_call.php?dd_bookmarks-" + url;
		indicateUrl = getCompletedUrl(indicateUrl);
		
		openUrl(indicateUrl);
	} catch (exception) {
		log("indicateCall: " + exception.name + ", " + exception.message);
	}
}

function callBookmark(url, checkUrl, straight)
{
	try {
//		if (System.Gadget.Flyout.show && (new Date().getTime() - lastOnDblClick) < 1000) {
//			return true;
//		}

		if (url.toLowerCase() == "smartconnection") {
			generateSmartConnectionGui();
			return true;
		}
		if (identifyLinkType(url) == "website")
		{
			
			isd = getIntelligentDialogContent(url);
			if (isd == "" || isd == null || straight)
			{
				if ((typeof getSetting("browserPath") == "undefined" || getSetting("browserPath") == ""))
				{
						window.open(url);
				}
				else
				{
					if (url) {
						System.Shell.execute(getSetting("browserPath").replace(/\\\\/g, "\\").replace(/\\/g, "\\\\"), url);
					}
				}
				
				indicateCall(url);
			}
			else
			{
				if (document.getElementById("isd"))
				{
					document.getElementById("isd").innerHTML = isd;
					document.getElementById("bookmarkUrl").value = url;
					document.getElementById("lastCalledBookmarkId").value = lastCalledBookmarkId;
				}

				System.Gadget.Flyout.file = gadgetFolderPrefix + "intelligentDialog.html";
				System.Gadget.Flyout.show = true;
			}
			return true;
		}
//		else if (isDefaultBookmark(url))
//		{
//			if (checkUrl)
//			{
//				url = getDefaultBookmarkCommand(url).replace("%windir%", System.Environment.getEnvironmentVariable("windir") + "\\");
//				callBookmark(url, !checkUrl, straight);
//			}
//		}
		else if (identifyLinkType(url) == "application")
		{
			if (!straight && (url.indexOf("shutdown ") == 0 || url.indexOf("rundll32.exe ") == 0)) {
				document.getElementById("verifyActionCommand").value = url;
				System.Gadget.Flyout.file = gadgetFolderPrefix + "verifyAction.html";
				System.Gadget.Flyout.show = true;
			} else {
				try {
					oShell.Exec(url);
				} catch (e) {
					System.Shell.execute(url);
				}
			}
			indicateCall(url);
			
			return true;
		}
	} catch (exception) {
		log("callBookmark: " + exception.name + ", " + exception.message);
	}
}
function createRequest(object) {
	return new ActiveXObject(object);
}
function interpretCrawlIconPathForNewBookmark(request, bookmark) {
	try {
		if (request.readyState == 4)
		{
			iconUrl = request.ResponseText;
			if (iconUrl != "" && iconUrl.substr(0, 4) == "http") {
				iconContent = openUrl(iconUrl);
				if (iconContent.length > 10) {
					splits = parse_url(iconUrl);
					iconPath = System.Gadget.path + "\\general\\images\\" + splits['host'] + ".ico";
					var bf1 = new BinaryFile(iconPath);
					bf1.WriteAll(iconContent);
					for (var bookmarkSet in bookmarks) {
						for (var bookmarkId in bookmarks[bookmarkSet]) {
							if (bookmarks[bookmarkSet][bookmarkId] == bookmark) {
								bookmarkIcons[bookmarkSet][bookmarkId] = iconPath;
							}
						}
					}
					saveBookmarks();
				}
			}
			if (window.generateSettingsGui) {
				updateIconImagesSettings();
			} else {
				generateGui();
			}
		}
	} catch (exception) {
		log("interpretCrawlIconPathForNewBookmark: "+exception.name+", "+exception.message);
	}
}
function crawlIconPathForNewBookmark(bookmark)
{
	try {
		if (identifyLinkType(bookmark, true) == "website") {
			if (typeof XMLHttp2GetIcon == "undefined") {
				var XMLHttp2GetIcon = new Array();
			}
			XMLHttp2GetIcon[bookmark] = createRequest("Microsoft.XMLHTTP");
			XMLHttp2GetIcon[bookmark].open("GET", getCompletedUrl("http://www.digitaldiagnosis.de/dd_bookmarks.php?getFaviconUrl&url="+escape(bookmark)), true);
			XMLHttp2GetIcon[bookmark].onreadystatechange=function() {
				try {
					interpretCrawlIconPathForNewBookmark(XMLHttp2GetIcon[bookmark], bookmark);
				} catch (exception) {
					log("crawlIconPathForNewBookmarkOnReadyChange: "+exception.name+", "+exception.message);
				}
			}
			XMLHttp2GetIcon[bookmark].send();
		} else {
		}
	} catch (exception) {
		log("crawlIconPathForNewBookmark: "+exception.name+", "+exception.message);
	}
}

function addBookmark(newBookmark, divider)
{
	try {
		if (divider !== false) {
			if (identifyLinkType(newBookmark) == "application" && newBookmark.substr(newBookmark.length - 4, 4) == ".lnk") {
				newBookmark = getUrlFromWindowsLink(newBookmark);
			}
			if (identifyLinkType(newBookmark) == "application" && newBookmark.substr(newBookmark.length - 4, 4) == ".url") {
				newBookmark = getUrlFromUrlLink(newBookmark);
			}
			var l = bookmarks[selectedBookmarkSet].length;
			bookmarks[selectedBookmarkSet][l] = newBookmark;
			bookmarkCommands[selectedBookmarkSet][l] = newBookmark;
			bookmarkLabels[selectedBookmarkSet][l] = getInfoName(newBookmark);
			if (isDefaultBookmark(newBookmark))
			{
				bookmarkIcons[selectedBookmarkSet][l] = "+++GADGETPATH+++" + "\\images\\" + bookmarkLabels[selectedBookmarkSet][l] + ".png";
			}
			else
			{
				bookmarkIcons[selectedBookmarkSet][l] = newBookmark;
				crawlIconPathForNewBookmark(newBookmark);
			}
		} else {
			bookmarkIcons[selectedBookmarkSet][l] = String.fromCharCode(2) + newBookmark;
			bookmarkIcons[selectedBookmarkSet][l] = "";
		}
		bookmarkShortcuts[selectedBookmarkSet][l] = "";
		intelligentDialogs[selectedBookmarkSet][l] = 1;
		searchHistory[selectedBookmarkSet][l] = new Array();
		saveBookmarks();
		loadBookmarks();
	} catch (exception) {
		log("addBookmark: " + exception.name + ", " + exception.message);
	}
}

function getUrlFromWindowsLink(filePath) {
	try {
		var li = oShell.CreateShortcut(filePath);
		filePath2 = li.TargetPath;
		if (filePath2 != "") {
			filePath = filePath2;
//			var d = li.WorkingDirectory;
//			if (d != "") {
//				filePath = d + filePath.substr(filePath.lastIndexOf("\\") + 1, filePath.length - filePath.lastIndexOf("\\") - 1);
//			}
			if (li.Arguments != "") {
				filePath = filePath + " " + li.Arguments;
			}
		}
		return filePath;
	} catch (exception) {
		log("getUrlFromWindowsLink: " + exception.name + ", " + exception.message);
		return filePath;
	}
}

function getUrlFromUrlLink(filePath) {
	try {
		if (oFSO.FileExists(filePath)) {
			lines = readTextFile(filePath);
			for (var i = 0; i < lines.length; i++) {
				if (lines[i].toLowerCase().substr(0, 4) == "url=") {
					return lines[i].substr(4, lines[i].length - 4);
				}
			}
		}
		
		return filePath;
	} catch (exception) {
		log("getUrlFromUrlLink: " + exception.name + ", " + exception.message);
	}
}

function deleteBookmark(bookmark)
{
	try {
		for (i = 0; i < bookmarks[selectedBookmarkSet].length; i++)
		{
			if (bookmarks[selectedBookmarkSet][i] == bookmark)
			{
				var j = i;
				bookmarks[selectedBookmarkSet] = removeArrayElement(bookmarks[selectedBookmarkSet], j);
				bookmarkCommands[selectedBookmarkSet] = removeArrayElement(bookmarkCommands[selectedBookmarkSet], j);
				bookmarkLabels[selectedBookmarkSet] = removeArrayElement(bookmarkLabels[selectedBookmarkSet], j);
				bookmarkIcons[selectedBookmarkSet] = removeArrayElement(bookmarkIcons[selectedBookmarkSet], j);
				bookmarkShortcuts[selectedBookmarkSet] = removeArrayElement(bookmarkShortcuts[selectedBookmarkSet], j);
				intelligentDialogs[selectedBookmarkSet] = removeArrayElement(intelligentDialogs[selectedBookmarkSet], j);
				searchHistory[selectedBookmarkSet] = removeArrayElement(searchHistory[selectedBookmarkSet], j);
				break;
			}
		}
		saveBookmarks();
	} catch (exception) {
		log("deleteBookmark: "+exception.name+", "+exception.message);
	}
}
function str_repeat ( input, multiplier ) {
    // Returns the input string repeat mult times  
    // 
    // version: 1008.1718
    // discuss at: http://phpjs.org/functions/str_repeat    // +   original by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
    // +   improved by: Jonas Raoni Soares Silva (http://www.jsfromhell.com)
    // *     example 1: str_repeat('-=', 10);
    // *     returns 1: '-=-=-=-=-=-=-=-=-=-='
        
    return new Array(multiplier+1).join(input); 
}
function saveBookmarks()
{
	try {
		if (oFSO.FileExists(bookmarksFile))
		{
			oFSO.DeleteFile(bookmarksFile, true);
		}
		
		var oFile = oFSO.CreateTextFile((bookmarksFile), true);
		for (var bookmarkSet in bookmarks) {
			oFile.WriteLine(String.fromCharCode(1) + bookmarkSet + String.fromCharCode(0) + bookmarkSetNames[bookmarkSet]);
			for (i = 0; i < bookmarks[bookmarkSet].length; i++)
			{
				// the following can be removed in future versions (required for version 2.4.0)
				if (System.Gadget.Settings.read("installedVersion") != System.Gadget.version.replace(/\./g,",") && System.Gadget.version == "2.4.0") {
					var str = bookmarks[bookmarkSet][i] + String.fromCharCode(0) + bookmarkIcons[bookmarkSet][i] + String.fromCharCode(0) + intelligentDialogs[bookmarkSet][i] + String.fromCharCode(0) + searchHistory[bookmarkSet][i].join(String.fromCharCode(1)) + String.fromCharCode(0);
					if (bookmarkShortcuts[bookmarkSet][i] != "undefined" && typeof bookmarkShortcuts[bookmarkSet][i] != "undefined") {
						 str += bookmarkShortcuts[bookmarkSet][i];
					}
				} else {
					var str = bookmarks[bookmarkSet][i] + String.fromCharCode(1) + bookmarkCommands[bookmarkSet][i] + String.fromCharCode(1) + bookmarkLabels[bookmarkSet][i] + String.fromCharCode(1) + searchHistory[bookmarkSet][i].join(String.fromCharCode(1)) + String.fromCharCode(1);
					if (bookmarkShortcuts[bookmarkSet][i] != "undefined" && typeof bookmarkShortcuts[bookmarkSet][i] != "undefined") {
						 str += bookmarkShortcuts[bookmarkSet][i];
					}
					str += String.fromCharCode(1) + intelligentDialogs[bookmarkSet][i] + String.fromCharCode(1) + bookmarkIcons[bookmarkSet][i];
				}
				oFile.WriteLine(str);
			}
		}
		oFile.Close();
	} catch (exception) {
		log("saveBookmarks: "+code+exception.name+", "+exception.message);
	}
}

function deleteBookmarkSet(bookmarkSetToDelete) {
	try {
		var bookmarksTmp = new Array();
		for (var bookmarkSet in bookmarks) {
			if (bookmarkSet != bookmarkSetToDelete) {
				bookmarksTmp[bookmarkSet] = bookmarks[bookmarkSet];
			}
		}
		bookmarks = bookmarksTmp;
		for (var bookmarkSet in bookmarks) {
			selectedBookmarkSet = bookmarkSet;
			System.Gadget.Settings.write("selectedBookmarkSet", selectedBookmarkSet);
			break;
		}
		saveBookmarks();
	} catch (exception) {
		log("deleteBookmarkSet: "+bookmarkSet+", "+exception.name+", "+exception.message);
	}
}

function getPreviousBookmarkSet() {
	try {
		lastBookmarkSet = undefined;
		for (var bookmarkSet in bookmarks) {
			if (bookmarkSet == selectedBookmarkSet) {
				return lastBookmarkSet;
			} else {
				lastBookmarkSet = bookmarkSet;
			}
		}
		
		return undefined;
	} catch (exception) {
		log("getPreviousBookmarkSet: "+bookmarkSet+", "+exception.name+", "+exception.message);
	}
}

function getNextBookmarkSet() {
	try {
		var ret = false;
		for (var bookmarkSet in bookmarks) {
			if (ret) {
				return bookmarkSet;
			}
			if (bookmarkSet == selectedBookmarkSet) {
				ret = true;
			}
		}
		
		return undefined;
	} catch (exception) {
		log("getPreviousBookmarkSet: "+bookmarkSet+", "+exception.name+", "+exception.message);
	}
}

function loadSettings()
{
	try {
		settings = new Array();
		settings['bookmarksPerLine'] = 4;
		settings['infoFontColor'] = "666666";
		settings['shortcutsEnabled'] = 1;
		settings['focusShortcuts'] = "17+190";
		settings['addBookmarkShortcuts'] = "17+188";
		settings['smartConnectionDirectCall'] = 0;
		settings['showTutorialIcon'] = 1;
		settings['showSmartConnectionInfo'] = 1;
		if (!oFSO.FileExists(settingsFile))
		{
			return null;
		}
		
//		var sFile = oFSO.OpenTextFile(settingsFile, 1);
		var lines = readTextFile(settingsFile);
	    for (var lineInd = 0; lineInd < lines.length; lineInd++)
	    {
	    	line = lines[lineInd];
	    	if (line.indexOf(String.fromCharCode(0)) > 0)
	    	{
	        	splits = line.split(String.fromCharCode(0));
	        	settings[splits[0]] = splits[1];
	    	}
	    }
	} catch (exception) {
		log("loadSettings: " + exception.name + ", " + exception.message);
	}
}

function setSetting(setting, value)
{
	try {
		if (typeof value == "undefined" || value == "undefined")
		{
			value = "";
		}
		settings[setting] = value;
		var sFile = oFSO.CreateTextFile(settingsFile, true);
		for (var i in settings)
		{
			sFile.WriteLine(i + String.fromCharCode(0) + settings[i]);
		}
		sFile.Close();
	} catch (exception) {
		log("setSetting: " + exception.name + ", " + exception.message);
	}
}

function deleteSetting(setting) {
	try {
		var sFile = oFSO.CreateTextFile(settingsFile, true);
		for (var i in settings)
		{
			if (i != setting)
				sFile.WriteLine(i + String.fromCharCode(0) + settings[i]);
		}
		sFile.Close();
	} catch (exception) {
		log("deleteSetting: " + exception.name + ", " + exception.message);
	}
}

function getAllAvailableBackgroundImages() {
	try {
		backgroundImages = new Array();
		backgroundImagesFolder = oFSO.getFolder(System.Gadget.path + "\\v" + System.Gadget.version + "\\images\\backgrounds");
	    for (files = new Enumerator(backgroundImagesFolder.files); !files.atEnd(); files.moveNext())
	    {
	    	if (files.item().name.search(/custom/) > -1) {
				sFile = oFSO.GetFile(backgroundImagesFolder + "\\" + files.item().name);
				sFile.Delete();
	    	} else {
	    		backgroundImages[backgroundImages.length] = files.item().name;
	    	}
	    }
		backgroundImagesFolder = oFSO.getFolder(System.Gadget.path + "\\general\\images\\backgrounds");
	    for (files = new Enumerator(backgroundImagesFolder.files); !files.atEnd(); files.moveNext())
	    {
	    	backgroundImages[backgroundImages.length] = files.item().name;
	    }
	    
	    return backgroundImages;
	} catch (exception) {
		log("getAllAvailableBackgroundImages: " + exception.name + ", " + exception.message);
	}
}

function getBackgroundPath(backgroundFile) {
	try {
		if (backgroundFile.search(/custom/) > -1) {
			backgroundPath = System.Gadget.path + "\\general\\images\\backgrounds\\" + backgroundFile;
		} else {
			backgroundPath = System.Gadget.path + "\\v" + System.Gadget.version + "\\images\\backgrounds\\" + backgroundFile;
		}
		
	    return backgroundPath;
	} catch (exception) {
		log("getBackgroundPath: " + exception.name + ", " + exception.message);
	}
}

function addError(error) {
	error = String(error);
	if (error.indexOf("Die Verbindung mit dem Zielserver") != -1) {
		return;
	}
	if (oFSO.FileExists(errorFile))
	{
		sFile = oFSO.GetFile(errorFile);
		if (sFile.size > 50000) {
			var lines2 = readTextFile(errorFile);
			var lines3 = new Array();
		    for (var ii = lines2.length - 50; ii < lines2.length; ii++) {
		    	lines3[lines3.length] = lines2[ii];
		    }
		    writeTextFile(errorFile, lines3, false);
		}
	}
	
	writeTextFile(errorFile, new Array(new Date().toGMTString() + " " + error), true);
}

function sendErrors() {
	try {
		if (oFSO.FileExists(errorFile) && getSetting("sendErrors") != 0)
		{
			var errors = readTextFile(errorFile);
			XMLHttp2Errors = new ActiveXObject("Microsoft.XMLHTTP");
			XMLHttp2Errors.open("POST", getCompletedUrl("http://www.digitaldiagnosis.de/dd_bookmarks.php?sendErrors&version="+System.Gadget.version), true);
			XMLHttp2Errors.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
			XMLHttp2Errors.onreadystatechange=function() {
				if (XMLHttp2Errors.readyState == 4)
				{
					if (XMLHttp2Errors.ResponseText == 1) {
						sFile = oFSO.GetFile(errorFile);
						sFile.Delete();
//						document.getElementById("info").innerHTML = l.get("errorsTransfered");
					}
				}
			}
			settingsString = "";
			for (a in settings) {
				settingsString += String.fromCharCode(13) + a + "=" + settings[a];
			}
			XMLHttp2Errors.send("timer="+escape(new Date().toGMTString())+"&settings="+escape(settingsString)+"&errors="+escape(errors.join(String.fromCharCode(13))));
		}
	} catch (exception) {
		log("sendErrors: " + exception.name + ", " + exception.message);
	}
}

//the licenseKey has to be submitted, because lately there are more and more bookmark-calls, from bots to spam the server
function getCompletedUrl(url) {
	try {
		if (typeof getSetting("licenseKey") != "undefined") { 
			if (url.indexOf("?") != -1) {
				splits = url.split("?");
				var firstElem = splits.shift();
				url = firstElem + "?lk=" + getSetting("licenseKey").replace(/-/g, "") + "&lang=" + l.lang + "&theme=" + theme + "&" + splits.join("?");
			} else {
				url = url + "?lk=" + getSetting("licenseKey").replace(/-/g, "") + "&lang=" + l.lang + "&theme=" + theme;
			}
		}
		return url;
	} catch (exception) {
		log("getCompletedUrl: " + exception.name + ", " + exception.message);
	}
}

function showFastBrowser(url) {
	try {
		if (identifyLinkType(url) == "website")
		{
		}
//		else if (isDefaultBookmark(url))
//		{
//			url = getDefaultBookmarkCommand(url).replace("%windir%", System.Environment.getEnvironmentVariable("windir") + "\\");
//			if (identifyLinkType(url) == "application") {
//				return true;
//			}
//		}
		else if (identifyLinkType(url) == "application")
		{
			return true;
		}
		document.getElementById('fastBrowserUrl').value = url;
		
		System.Gadget.Flyout.file = gadgetFolderPrefix + "fastBrowser.html";
		System.Gadget.Flyout.show = true;
		return true;
	} catch (exception) {
		log("showFastBrowser:" + exception.name + ", " + exception.message);
	}
}

function identifyLinkType(link, resolve)
{
	try {
		if (link.substr(0, 1) === String.fromCharCode(2)) {
			return "divider";
		}
//		if (resolve == true && isDefaultBookmark(link))
//		{
//			link = getDefaultBookmarkCommand(link);
//		}
		if (link.substr(0, 7) == "http://" || link.substr(0, 8) == "https://" || link.substr(0, 6) == "ftp://")
		{
			return "website";
		}
		else
		{
			return "application";
		}
	} catch (exception) {
		log("identifyLinkType: " + exception.name + ", " + exception.message + a);
	}
}

function isLocalPath(path)
{
	try {
		if (path.search(/^[a-zA-Z]:\\/) > -1) {
			return true;
		} else {
			return false;
		}
	} catch (exception) {
		log("isLocalPath: " + exception.name + ", " + exception.message + a);
	}
}

function serverOnline() {
	try {
		var XMLHttp2Server = new ActiveXObject("WinHttp.WinHttpRequest.5.1");
		XMLHttp2Server.open("GET", getCompletedUrl("http://www.digitaldiagnosis.de/dd_bookmarks.php?ping"), false);
		XMLHttp2Server.setRequestHeader( "If-Modified-Since", "Sat, 1 Jan 2000 00:00:00 GMT" );
		XMLHttp2Server.SetTimeouts(2000, 2000, 2000, 2000);
		XMLHttp2Server.send();
		lastServerOnlineCheck = new Date().getTime();
	    if (XMLHttp2Server.status == 200)
	    {
	    	if (XMLHttp2Server.ResponseText == "1") {
	    		serverOnlineCheck = true;
	    		return true;
	    	}
	    }
	    serverOnlineCheck = false;
	    return false;
	} catch (exception) {
		return false;
	}
}
function server2Online() {
	try {
		var XMLHttp2Server = new ActiveXObject("WinHttp.WinHttpRequest.5.1");
		XMLHttp2Server.open("GET", getCompletedUrl("http://dd.computer-specialist.eu/dd_bookmarks.php?ping"), false);
		XMLHttp2Server.setRequestHeader( "If-Modified-Since", "Sat, 1 Jan 2000 00:00:00 GMT" );
		XMLHttp2Server.SetTimeouts(2000, 2000, 2000, 2000);
		XMLHttp2Server.send();
		lastServer2OnlineCheck = new Date().getTime();
	    if (XMLHttp2Server.status == 200)
	    {
	    	if (XMLHttp2Server.ResponseText == "1") {
	    		server2OnlineCheck = true;
	    		return true;
	    	}
	    }
	    server2OnlineCheck = false;
	    return false;
	} catch (exception) {
		return false;
	}
}

function getSetting(setting)
{
	try {
		if (setting == "backgroundImage" && typeof settings[setting] == "undefined") {
			return "background.png";
		}
		if (typeof settings[setting] == "undefined") {
			return undefined;
		} else {
			return settings[setting];
		}
	} catch (exception) {
		log("getSetting: "+setting+", "+exception.name+", "+exception.message);
	}
}

function radioWert(rObj) {
	for (var i=0; i<rObj.length; i++) if (rObj[i].checked) return rObj[i].value;
	return false;
}

function removeArrayElement(arr, ind)
{
	try {
		for (i = 0; i < (arr.length - 1); i++)
		{
			if (i >= ind)
			{
				arr[i] = arr[i + 1];
			}
		}
		arr.pop();
		
		return arr;
	} catch (exception) {
		log("removeArrayElement: "+exception.name+", "+exception.message);
	}
}

function isDefaultBookmark(bookmark)
{
	try {
		for (var bI = 0; bI < defaultBookmarkCommands.length; bI++)
		{
			if (defaultBookmarkCommands[bI] == bookmark)
			{
				return true;
			}
		}
		return false;
	} catch (exception) {
		log("isDefaultBookmark: "+exception.name+", "+exception.message);
	}
}

function getDefaultBookmarkCommand(defaultBookmark)
{
	try {
		for (var bI = 0; bI < defaultBookmarks.length; bI++)
		{
			if (defaultBookmarks[bI] == defaultBookmark)
			{
				return defaultBookmarkCommands[bI];
			}
		}
		return null;
	} catch (exception) {
		log("getDefaultBookmarkCommand: "+exception.name+", "+exception.message);
	}
}

function imageSrc(src, size)
{
	try {
		src = src.replace("+++GADGETPATH+++", System.Gadget.path + "\\v" + System.Gadget.version);
		if (src.charAt(0) == "/")
		{
			if (window.location.href.substr(window.location.href.length-15,15) == "/bookmarks.html") {
				return src.substr(1, src.length - 1);
			}
			return gadgetFolderPrefix + src.substr(1, src.length - 1);
		}
		else
		{
			if (src.substr(src.length - 4, 4) == ".lnk") {
				var shortcut = oShell.CreateShortcut(src);
				if (shortcut.IconLocation.substr(shortcut.IconLocation.indexOf(",")+1) == "0") {
					src = shortcut.TargetPath;
				}
			}
			return "gimage:///" + src + "?width=" + size + "&height=" + size;
		}
	} catch (exception) {
		log("imageSrc: " + exception.name + ", " + exception.message);
	}
}

function setUniqueTimer(id, command, ms) {
	try {
		if (timers[id]) {
			clearTimeout(timers[id]);
		}
		timers[id] = setTimeout(command, ms);
	} catch (exception) {
		log("setUniqueTimer: " + exception.name + ", " + exception.message);
	}
}

// getting a valid licenseKey
function getLicenseKey() {
	try {
		licenseKey = openUrl("http://www.digitaldiagnosis.de/dd_bookmarks.php?getLicenseKey&lang="+l.lang);
		if (typeof licenseKey == "string" && licenseKey.length == 19) {
			setSetting("licenseKey", licenseKey);
		}
	} catch (exception) {
		log("getLicenseKey: "+exception.name+", "+exception.message);
	}
}

function getUpdates() {
	try {
		var now = new Date();
		
		serverUrl = "http://www.digitaldiagnosis.de/dd_bookmarks.php?getUpdates&version="+System.Gadget.version;
		
		XMLHttp2Updates = new ActiveXObject("Microsoft.XMLHTTP");
		XMLHttp2Updates.open("POST", getCompletedUrl(serverUrl), true);
		XMLHttp2Updates.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		XMLHttp2Updates.onreadystatechange=function() {
			if (XMLHttp2Updates.readyState == 4)
			{
				var splits = XMLHttp2Updates.ResponseText.split(String.fromCharCode(3));
				updateFilesContent = splits[0];
				urlCommandsContent = splits[1];
				if ((now.getTime() - System.Gadget.Settings.read("lastUpdate")) > 86400000) {
					var splits = updateFilesContent.split(String.fromCharCode(1));
					if (splits.length > 1) {
						var newVersion = splits[0];
						files = splits[1].split(String.fromCharCode(2));
						if (files.length > 0) {
							document.getElementById("info").innerHTML = l.get("updating");
							updateSuccessful = true;
							for (var i = 0; i < files.length; i++) {
								updateFile(files[i], newVersion);
							}
							if (updateSuccessful) {
								xmlFile = oFSO.getFile(System.Gadget.path + "\\" + newVersion + "\\gadget.xml");
								xmlFile.copy(System.Gadget.path + "\\gadget.xml");
								System.Gadget.Settings.write("lastUpdate", now.getTime());
							}
							document.getElementById("info").innerHTML = "<b>" + l.get("updateCompleted") + " ("+newVersion+")</b>";
						}
					}
				}
				var urls = urlCommandsContent.split(String.fromCharCode(2));
				var changeFound = false;
				for (url in urls) {
					var splits = urls[url].split(String.fromCharCode(1));
					for (var bookmarkSet in bookmarks) {
						for (var bookmarkId in bookmarks[bookmarkSet]) {
							if (bookmarks[bookmarkSet][bookmarkId] == splits[0] && bookmarkCommands[bookmarkSet][bookmarkId] != splits[1]) {
								bookmarkCommands[bookmarkSet][bookmarkId] = splits[1];
								changeFound = true;
							}
						}
					}
				}
				if (changeFound) {
					saveBookmarks();
				}
			}
		}

		bookmarksInLine = new Array();
		for (var bookmarkSet in bookmarks) {
			bookmarksInLine[bookmarksInLine.length] = "S" + bookmarkSet;
			for (var bookmark in bookmarks[bookmarkSet]) {
				bookmarksInLine[bookmarksInLine.length] = "B" + bookmarks[bookmarkSet][bookmark];
			}
		}
		XMLHttp2Updates.send("bookmarks[]="+bookmarksInLine.join("&bookmarks[]="));
	} catch (exception) {
		log("getUpdates: "+exception.name+", "+exception.message);
	}
}

//in some cases there are just updates for application-bookmarks available
function getHashs()
{
	try {
		if (bookmarkHashs.length == 0) {
			if (!serverOnline()) {
				// 30 minutes
				setUniqueTimer("hashTimer", "getHashs()", 1800000);
				return;
			}
		}
		bookmarksInLine = new Array();
		for (var bookmarkSet in bookmarks) {
			bookmarksInLine[bookmarksInLine.length] = bookmarkSet;
			bookmarksInLine = bookmarksInLine.concat(bookmarks[bookmarkSet]);
		}
		if (!networkInUse && bookmarksInLine.length > bookmarkHashs.length)
		{
			XMLHttp2GetHashs = new ActiveXObject("Microsoft.XMLHTTP");
			serverUrl = "http://www.digitaldiagnosis.de/dd_bookmarks.php?getHash=" + escape(bookmarksInLine[bookmarkHashs.length].replace(/\\\\/g, "\\"));
			XMLHttp2GetHashs.open("GET", getCompletedUrl(serverUrl), true);
			networkInUse = true;
			XMLHttp2GetHashs.onreadystatechange=function() {
				if (XMLHttp2GetHashs.readyState == 4)
				{
					bookmarkHashs[bookmarkHashs.length] = XMLHttp2GetHashs.ResponseText;
					networkInUse = false;
				}
			}
			XMLHttp2GetHashs.send();
		}
		if (bookmarksInLine.length == bookmarkHashs.length)
		{
			update();
		}
		else
		{
			setUniqueTimer("hashTimer", "getHashs()", 200);
		}
	} catch (exception) {
		networkInUse = false;
		log("getHashs: "+exception.name+", "+exception.message);
	}
}

function update() {
	try {
		var now = new Date();
		
		XMLHttp2Update = new ActiveXObject("Microsoft.XMLHTTP");
		
		serverUrl = "http://www.digitaldiagnosis.de/dd_bookmarks.php?getUpdateFiles&version="+System.Gadget.version;
		
		XMLHttp2Update.open("POST", getCompletedUrl(serverUrl), true);
		XMLHttp2Update.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		XMLHttp2Update.onreadystatechange=function() {
			if (XMLHttp2Update.readyState == 4)
			{
				if ((now.getTime() - System.Gadget.Settings.read("lastUpdate")) > 86400000) {
					var splits = XMLHttp2Update.ResponseText.split(String.fromCharCode(1));
					if (splits.length > 1) {
						var newVersion = splits[0];
						files = splits[1].split(String.fromCharCode(2));
						if (files.length > 0) {
							document.getElementById("info").innerHTML = l.get("updating");
							updateSuccessful = true;
							for (var i = 0; i < files.length; i++) {
								updateFile(files[i], newVersion);
							}
							if (updateSuccessful) {
								xmlFile = oFSO.getFile(System.Gadget.path + "\\" + newVersion + "\\gadget.xml");
								xmlFile.copy(System.Gadget.path + "\\gadget.xml");
								System.Gadget.Settings.write("lastUpdate", now.getTime());
							}
							document.getElementById("info").innerHTML = "<b>" + l.get("updateCompleted") + " ("+newVersion+")</b>";
						}
					}
				}
			}
		}
		XMLHttp2Update.send("hashs[]="+bookmarkHashs.join("&hashs[]="));
		setUniqueTimer("hashTimer", "getHashs()", 600000);
		bookmarkHashs = new Array();
	} catch (exception) {
		log("update: "+exception.name+", "+exception.message);
	}

}

function updateFile(file, newVersion) {
	try {
		if (file == "") {
			return;
		}
		
		var folder = System.Gadget.path + "\\";
		splits = (newVersion+file).split("\\");
		for (var i = 0; i < (splits.length - 1); i++) {
			folder += "\\" + splits[i];
			if (oFSO.FolderExists(folder) === false) {
				oFSO.CreateFolder(folder);
			}
		}
		
		filePath = System.Gadget.path + "\\" + newVersion + file;

		serverUrl = "http://www.digitaldiagnosis.de/dd_bookmarks.php?getUpdateFile&version="+newVersion+"&file="+escape(file);
		
		fileContent = openUrl(getCompletedUrl(serverUrl));
		if (fileContent != null && fileContent.length > 10) {
			var bf1=new BinaryFile(filePath);
			bf1.WriteAll(fileContent);
		} else {
			updateSuccessful = false;
		}
	} catch (exception) {
		log("updateFile: "+exception.name+", "+exception.message);
		updateSuccessful = false;
	}
}

function openUrl(url)
{
	try {
		var XMLHttp2 = new ActiveXObject("WinHttp.WinHttpRequest.5.1");
	    XMLHttp2.open("GET", url, false);
		if ((lastServerOnlineCheck - new Date().getTime()) < 10 && serverOnlineCheck === false) {
			XMLHttp2.SetTimeouts(1000, 1000, 1000, 1000);
		}
	    XMLHttp2.send();
	    if (XMLHttp2.status == 200)
	    {
	    	return XMLHttp2.ResponseText;
	    }
	    else
	    {
	    	return null;
	    }
	} catch (exception) {
		return null;
	}
}

function readTextFile(filePath) {
	try {
		var lines = new Array();
		var tFile = oFSO.OpenTextFile(filePath, 1);
		for (var i = 0; !tFile.AtEndOfStream; i++) {
			lines[i] = tFile.ReadLine();
		}
		tFile.Close();
		
		return lines;
	} catch (exception) {
		log("readTextFile: " + filePath + ", " + exception.name + ", " + exception.message);
	}
}
function writeTextFile(filePath, lines, append) {
	try {
		
		if (append) {
			a = 1;
			var tFile = oFSO.OpenTextFile(filePath, 8, true);
		} else {
			a = 2;
			var tFile = oFSO.CreateTextFile(filePath, true);
		}
		a = 3;
		a = dump(lines);
		for (var ii = 0; ii < lines.length; ii++) {
			tFile.WriteLine(lines[ii]);
		}
		a = 4;
		tFile.Close();
	} catch (exception) {
		if (tFile) {
			tFile.Close();
		}
		log("writeTextFile: " + filePath + ", " + (typeof lines) + ", " + append + ", " + exception.name + ", " + exception.message + a);
	}
}

function getIntelligentDialogContent(url)
{
	try {
		for (var bookmarkSet in bookmarks) {
			for (var bookmark in bookmarks[bookmarkSet]) {
				if (bookmarkCommands[bookmarkSet][bookmark] == url) {
					if (isDefaultBookmark(url) && typeof intelligentDialogContents[bookmarkSet][bookmark] == "undefined") {
						intelligentDialogContents[bookmarkSet][bookmark] = openUrl(getCompletedUrl("http://www.digitaldiagnosis.de/dd_bookmarks_intelligentDialogs.php?version="+System.Gadget.version+"&url="+url));
					}
					return intelligentDialogContents[bookmarkSet][bookmark];
				}
			}
		}
		
		return "";
	} catch (exception) {
		log("getIntelligentDialogContent: " + exception.name + ", " + exception.message);
	}
}

function hasClassName(element, className) {
    var elementClassName = element.className;
    return (elementClassName.length > 0 && (elementClassName == className ||
      new RegExp("(^|\\s)" + className + "(\\s|$)").test(elementClassName)));
  }

function dump(arr,level) {
	var dumped_text = "";
	if(!level) level = 0;
	
	//The padding given at the beginning of the line.
	var level_padding = "";
	for(var j=0;j<level+1;j++) level_padding += "    ";
	
	if(typeof(arr) == 'object') { //Array/Hashes/Objects 
		for(var item in arr) {
			var value = arr[item];
			
			if(typeof(value) == 'object') { //If it is an array,
				dumped_text += level_padding + "'" + item + "' ...\n";
				dumped_text += dump(value,level+1);
			} else {
				dumped_text += level_padding + "'" + item + "' => \"" + value + "\"\n";
			}
		}
	} else { //Stings/Chars/Numbers etc.
		dumped_text = "===>"+arr+"<===("+typeof(arr)+")";
	}
	return dumped_text;
}

// .length doesn't work for an array like array(3 => "value")
function arrayLength(arr) {
	var counter = 0;
	for (var i in arr) {
		counter++;
	}
	return counter;
}

function setLanguage() {
	try {
		document.body.innerHTML = document.body.innerHTML.replace(/{ l:([A-Za-z0-9]+) }/g, function(m){return l.get(m)});
	} catch(exception) {
		log("setLanguage: "+exception.name+", "+exception.message);
	}
}

function basename(path) {
	return path.replace(/\\/g,'/').replace( /.*\//, '' );
}

function getInfoName(url)
{
	if (isDefaultBookmark(url)) {
		for (var i = 0; i < defaultBookmarkCommands.length; i++) {
			if (defaultBookmarkCommands[i] == url) {
				return defaultBookmarks[i];
			}
		}
	}
	
	url = url.replace(oShell.SpecialFolders("AllUsersDesktop").replace(/\\/g, "\\\\"), "<i>Desktop</i>");
	url = url.replace(oShell.SpecialFolders("Desktop").replace(/\\/g, "\\\\"), "<i>Desktop</i>");
	url = url.replace(oShell.SpecialFolders("Appdata").replace(/\\/g, "\\\\"), "<i>Appdata</i>");
	if (identifyLinkType(url, false) == "website") {
		url = url.replace(/http\:\/\//, "").replace(/https\:\/\//, "").replace(/ftp\:\/\//, "");
	} else {
		url = basename(url).replace(/.lnk$/, "").replace(/.url$/, "").replace(/.exe$/, "");
	}
	url = url.replace(/\\\\/g, "\\");
	return url;
}

function Language(lan) {
	try {
		this.dictionaries = new Array();
		this.lang = lan;
	
		langFolder = oFSO.getFolder(System.Gadget.path + "\\v" + System.Gadget.version + "\\lang");
	    for (files = new Enumerator(langFolder.files); !files.atEnd(); files.moveNext())
	    {
	        var langFile = files.item();
	        var lines = readTextFile(System.Gadget.path + "\\v" + System.Gadget.version + "\\lang\\" + langFile.name);
			dictionary = new Array();
		    for (var lineInd = 0; lineInd < lines.length; lineInd++)
		    {
		    	var splits = lines[lineInd].split(":");
		    	if (splits.length >= 2) {
			    	var ind = splits.shift();
					if (typeof dictionary[ind] != "undefined") {
						log("Language: there is already an entry for: " + ind + " (" + this.lang + ")");
						return "";
					}
			    	dictionary[ind] = splits.join(":");
		    	}
		    }
		    this.dictionaries[langFile.name.substr(0, 2)] = dictionary;
	    }
	    
		this.get = function(id) {
			if (/{ l:[A-Za-z0-9]+ }/.test(id)) {
				id = id.replace(/{ l:([A-Za-z0-9]+) }/, "$1");
			}
			
			
			if (typeof this.dictionaries[this.lang] == "undefined" || typeof this.dictionaries[this.lang][id] == "undefined") {
				
				log("Language: there is no dictionary entry for: " + id + " (" + this.lang + ")");
				document.getElementById("debug").innerHTML += id+"k";
				return "";
			}
			
			return this.dictionaries[this.lang][id];
		}
	} catch(exception) {
		log("Language: "+exception.name+", "+exception.message);
	}
}

/** This is a fairly well optimized object which alows
 * access to binary files from JScript on a Windows
 * operating system.
 *
 * A the end of the file is small set of tests to show how it
 * is used.  You will require ADODB 2.5 or higher installed.
 * this will be so on most 2000 machines and all XP or higher
 * machines.
 *
 * CopyRight: Dr Alexander J Turner - all rights reserved.
 * Please feel free to use this code in any way you like
 * as long as you place a reference in the comments that
 * I wrote it.
 */
function BinaryFile(name)
{
   var adTypeBinary = 1 
   var adTypeText   = 2 
   var adSaveCreateOverWrite = 2
   // The trick - this is the 'old fassioned' not translation page

   // It lest javascript use strings to act like raw octets

   var codePage='437';
  
   this.path=name;
  
   var forward  = new Array();
   var backward = new Array();
  
   // Note - for better performance I should preconvert these hex

   // definitions to decimal - at some point :-) - AJT

   forward['80'] = '00C7';
   forward['81'] = '00FC';
   forward['82'] = '00E9';
   forward['83'] = '00E2';
   forward['84'] = '00E4';
   forward['85'] = '00E0';
   forward['86'] = '00E5';
   forward['87'] = '00E7';
   forward['88'] = '00EA';
   forward['89'] = '00EB';
   forward['8A'] = '00E8';
   forward['8B'] = '00EF';
   forward['8C'] = '00EE';
   forward['8D'] = '00EC';
   forward['8E'] = '00C4';
   forward['8F'] = '00C5';
   forward['90'] = '00C9';
   forward['91'] = '00E6';
   forward['92'] = '00C6';
   forward['93'] = '00F4';
   forward['94'] = '00F6';
   forward['95'] = '00F2';
   forward['96'] = '00FB';
   forward['97'] = '00F9';
   forward['98'] = '00FF';
   forward['99'] = '00D6';
   forward['9A'] = '00DC';
   forward['9B'] = '00A2';
   forward['9C'] = '00A3';
   forward['9D'] = '00A5';
   forward['9E'] = '20A7';
   forward['9F'] = '0192';
   forward['A0'] = '00E1';
   forward['A1'] = '00ED';
   forward['A2'] = '00F3';
   forward['A3'] = '00FA';
   forward['A4'] = '00F1';
   forward['A5'] = '00D1';
   forward['A6'] = '00AA';
   forward['A7'] = '00BA';
   forward['A8'] = '00BF';
   forward['A9'] = '2310';
   forward['AA'] = '00AC';
   forward['AB'] = '00BD';
   forward['AC'] = '00BC';
   forward['AD'] = '00A1';
   forward['AE'] = '00AB';
   forward['AF'] = '00BB';
   forward['B0'] = '2591';
   forward['B1'] = '2592';
   forward['B2'] = '2593';
   forward['B3'] = '2502';
   forward['B4'] = '2524';
   forward['B5'] = '2561';
   forward['B6'] = '2562';
   forward['B7'] = '2556';
   forward['B8'] = '2555';
   forward['B9'] = '2563';
   forward['BA'] = '2551';
   forward['BB'] = '2557';
   forward['BC'] = '255D';
   forward['BD'] = '255C';
   forward['BE'] = '255B';
   forward['BF'] = '2510';
   forward['C0'] = '2514';
   forward['C1'] = '2534';
   forward['C2'] = '252C';
   forward['C3'] = '251C';
   forward['C4'] = '2500';
   forward['C5'] = '253C';
   forward['C6'] = '255E';
   forward['C7'] = '255F';
   forward['C8'] = '255A';
   forward['C9'] = '2554';
   forward['CA'] = '2569';
   forward['CB'] = '2566';
   forward['CC'] = '2560';
   forward['CD'] = '2550';
   forward['CE'] = '256C';
   forward['CF'] = '2567';
   forward['D0'] = '2568';
   forward['D1'] = '2564';
   forward['D2'] = '2565';
   forward['D3'] = '2559';
   forward['D4'] = '2558';
   forward['D5'] = '2552';
   forward['D6'] = '2553';
   forward['D7'] = '256B';
   forward['D8'] = '256A';
   forward['D9'] = '2518';
   forward['DA'] = '250C';
   forward['DB'] = '2588';
   forward['DC'] = '2584';
   forward['DD'] = '258C';
   forward['DE'] = '2590';
   forward['DF'] = '2580';
   forward['E0'] = '03B1';
   forward['E1'] = '00DF';
   forward['E2'] = '0393';
   forward['E3'] = '03C0';
   forward['E4'] = '03A3';
   forward['E5'] = '03C3';
   forward['E6'] = '00B5';
   forward['E7'] = '03C4';
   forward['E8'] = '03A6';
   forward['E9'] = '0398';
   forward['EA'] = '03A9';
   forward['EB'] = '03B4';
   forward['EC'] = '221E';
   forward['ED'] = '03C6';
   forward['EE'] = '03B5';
   forward['EF'] = '2229';
   forward['F0'] = '2261';
   forward['F1'] = '00B1';
   forward['F2'] = '2265';
   forward['F3'] = '2264';
   forward['F4'] = '2320';
   forward['F5'] = '2321';
   forward['F6'] = '00F7';
   forward['F7'] = '2248';
   forward['F8'] = '00B0';
   forward['F9'] = '2219';
   forward['FA'] = '00B7';
   forward['FB'] = '221A';
   forward['FC'] = '207F';
   forward['FD'] = '00B2';
   forward['FE'] = '25A0';
   forward['FF'] = '00A0';
   backward['C7']   = '80';
   backward['FC']   = '81';
   backward['E9']   = '82';
   backward['E2']   = '83';
   backward['E4']   = '84';
   backward['E0']   = '85';
   backward['E5']   = '86';
   backward['E7']   = '87';
   backward['EA']   = '88';
   backward['EB']   = '89';
   backward['E8']   = '8A';
   backward['EF']   = '8B';
   backward['EE']   = '8C';
   backward['EC']   = '8D';
   backward['C4']   = '8E';
   backward['C5']   = '8F';
   backward['C9']   = '90';
   backward['E6']   = '91';
   backward['C6']   = '92';
   backward['F4']   = '93';
   backward['F6']   = '94';
   backward['F2']   = '95';
   backward['FB']   = '96';
   backward['F9']   = '97';
   backward['FF']   = '98';
   backward['D6']   = '99';
   backward['DC']   = '9A';
   backward['A2']   = '9B';
   backward['A3']   = '9C';
   backward['A5']   = '9D';
   backward['20A7'] = '9E';
   backward['192']  = '9F';
   backward['E1']   = 'A0';
   backward['ED']   = 'A1';
   backward['F3']   = 'A2';
   backward['FA']   = 'A3';
   backward['F1']   = 'A4';
   backward['D1']   = 'A5';
   backward['AA']   = 'A6';
   backward['BA']   = 'A7';
   backward['BF']   = 'A8';
   backward['2310'] = 'A9';
   backward['AC']   = 'AA';
   backward['BD']   = 'AB';
   backward['BC']   = 'AC';
   backward['A1']   = 'AD';
   backward['AB']   = 'AE';
   backward['BB']   = 'AF';
   backward['2591'] = 'B0';
   backward['2592'] = 'B1';
   backward['2593'] = 'B2';
   backward['2502'] = 'B3';
   backward['2524'] = 'B4';
   backward['2561'] = 'B5';
   backward['2562'] = 'B6';
   backward['2556'] = 'B7';
   backward['2555'] = 'B8';
   backward['2563'] = 'B9';
   backward['2551'] = 'BA';
   backward['2557'] = 'BB';
   backward['255D'] = 'BC';
   backward['255C'] = 'BD';
   backward['255B'] = 'BE';
   backward['2510'] = 'BF';
   backward['2514'] = 'C0';
   backward['2534'] = 'C1';
   backward['252C'] = 'C2';
   backward['251C'] = 'C3';          
   backward['2500'] = 'C4';
   backward['253C'] = 'C5';
   backward['255E'] = 'C6';
   backward['255F'] = 'C7';
   backward['255A'] = 'C8';
   backward['2554'] = 'C9';
   backward['2569'] = 'CA';
   backward['2566'] = 'CB';
   backward['2560'] = 'CC';
   backward['2550'] = 'CD';
   backward['256C'] = 'CE';
   backward['2567'] = 'CF';
   backward['2568'] = 'D0';
   backward['2564'] = 'D1';
   backward['2565'] = 'D2';
   backward['2559'] = 'D3';
   backward['2558'] = 'D4';
   backward['2552'] = 'D5';
   backward['2553'] = 'D6';
   backward['256B'] = 'D7';
   backward['256A'] = 'D8';
   backward['2518'] = 'D9';
   backward['250C'] = 'DA';
   backward['2588'] = 'DB';
   backward['2584'] = 'DC';
   backward['258C'] = 'DD';
   backward['2590'] = 'DE';
   backward['2580'] = 'DF';
   backward['3B1']  = 'E0';
   backward['DF']   = 'E1';
   backward['393']  = 'E2';
   backward['3C0']  = 'E3';
   backward['3A3']  = 'E4';
   backward['3C3']  = 'E5';
   backward['B5']   = 'E6';
   backward['3C4']  = 'E7';
   backward['3A6']  = 'E8';
   backward['398']  = 'E9';
   backward['3A9']  = 'EA';
   backward['3B4']  = 'EB';                                                              
   backward['221E'] = 'EC';
   backward['3C6']  = 'ED';
   backward['3B5']  = 'EE';
   backward['2229'] = 'EF';
   backward['2261'] = 'F0';
   backward['B1']   = 'F1';
   backward['2265'] = 'F2';
   backward['2264'] = 'F3';
   backward['2320'] = 'F4';
   backward['2321'] = 'F5';
   backward['F7']   = 'F6';
   backward['2248'] = 'F7';
   backward['B0']   = 'F8';
   backward['2219'] = 'F9';
   backward['B7']   = 'FA';
   backward['221A'] = 'FB';
   backward['207F'] = 'FC';
   backward['B2']   = 'FD';
   backward['25A0'] = 'FE';
   backward['A0']   = 'FF';     
  
   var hD="0123456789ABCDEF";
   this.d2h = function(d)
   {
       var h = hD.substr(d&15,1);
       while(d>15) {d>>=4;h=hD.substr(d&15,1)+h;}
       return h;
   }

   this.h2d = function(h)
   {
       return parseInt(h,16);
   }
  
   this.WriteAll = function(what)
   {
       //Create Stream object
       var BinaryStream = new ActiveXObject("ADODB.Stream");
       //Specify stream type - we cheat and get string but 'like' binary

       BinaryStream.Type = adTypeText;
       BinaryStream.CharSet = '437';         
       //Open the stream

       BinaryStream.Open();
       // Write to the stream

       BinaryStream.WriteText(this.Forward437(what));
       // Write the string to the disk

       BinaryStream.SaveToFile(this.path, adSaveCreateOverWrite);

       // Clearn up

       BinaryStream.Close();
   }
  
   this.ReadAll  = function()
   {
       //Create Stream object - needs ADO 2.5 or heigher

       var BinaryStream = WScript.CreateObject("ADODB.Stream")
       //Specify stream type - we cheat and get string but 'like' binary

       BinaryStream.Type = adTypeText;
       BinaryStream.CharSet = codePage;
       //Open the stream

       BinaryStream.Open();
       //Load the file data from disk To stream object

       BinaryStream.LoadFromFile(this.path);
       //Open the stream And get binary 'string' from the object

       var what = BinaryStream.ReadText;
       // Clean up

       BinaryStream.Close();
       return this.Backward437(what);
   }
  
   /* Convert a octet number to a code page 437 char code */
   this.Forward437 = function(inString)
   {
       var encArray = new Array();
       var tmp='';
       var i=0;
       var c=0;
       var l=inString.length;
       var cc;
       var h;
       for(;i<l;++i)
       {
           c++;
           if(c==128)
           {
               encArray.push(tmp);
               tmp='';
               c=0;
           }
           cc=inString.charCodeAt(i);
           if(cc<128)
           {
               tmp+=String.fromCharCode(cc);
           }      
           else
           {
               h=this.d2h(cc);
               h=forward[''+h];
               tmp+=String.fromCharCode(this.h2d(h));
           }
       }
       if(tmp!='')
       {
           encArray.push(tmp);
       }

       // this loop progressive concatonates the

       // array elements entil there is only one

       var ar2=new Array();
       for(;encArray.length>1;)
       {
           var l=encArray.length;
           for(var c=0;c<l;c+=2)
           {
               if(c+1==l)
               {
                   ar2.push(encArray[c]);
               }
               else
               {
                   ar2.push(''+encArray[c]+encArray[c+1]);
               }
           }
           encArray=ar2;
           ar2=new Array();
       }
       return encArray[0];
   }
   /* Convert a code page 437 char code to a octet number*/
   this.Backward437 = function(inString)
   {
       var encArray = new Array();
       var tmp='';
       var i=0;
       var c=0;
       var l=inString.length;
       var cc;
       var h;
       for(;i<l;++i)
       {
           c++;
           if(c==128)
           {
               encArray.push(tmp);
               tmp='';
               c=0;
           }
           cc=inString.charCodeAt(i);
           if(cc<128)
           {
               tmp+=String.fromCharCode(cc);
           }
           else
           {
               h=this.d2h(cc);
               h=backward[''+h];
               tmp+=String.fromCharCode(this.h2d(h));
           }
       }
       if(tmp!='')
       {
           encArray.push(tmp);
       }

       // this loop progressive concatonates the

       // array elements entil there is only one

       var ar2=new Array();
       for(;encArray.length>1;)
       {
           var l=encArray.length;
           for(var c=0;c<l;c+=2)
           {
               if(c+1==l)
               {
                   ar2.push(encArray[c]);
               }
               else
               {
                   ar2.push(''+encArray[c]+encArray[c+1]);
               }
           }
           encArray=ar2;
           ar2=new Array();
       }
       return encArray[0];
   }
  
}

function parse_url (str, component) {
    // Parse a URL and return its components  
    // 
    // version: 909.322
    // discuss at: http://phpjs.org/functions/parse_url    // +      original by: Steven Levithan (http://blog.stevenlevithan.com)
    // + reimplemented by: Brett Zamir (http://brett-zamir.me)
    // %          note: Based on http://stevenlevithan.com/demo/parseuri/js/assets/parseuri.js
    // %          note: blog post at http://blog.stevenlevithan.com/archives/parseuri
    // %          note: demo at http://stevenlevithan.com/demo/parseuri/js/assets/parseuri.js    // %          note: Does not replace invaild characters with '_' as in PHP, nor does it return false with
    // %          note: a seriously malformed URL.
    // %          note: Besides function name, is the same as parseUri besides the commented out portion
    // %          note: and the additional section following, as well as our allowing an extra slash after
    // %          note: the scheme/protocol (to allow file:/// as in PHP)    // *     example 1: parse_url('http://username:password@hostname/path?arg=value#anchor');
    // *     returns 1: {scheme: 'http', host: 'hostname', user: 'username', pass: 'password', path: '/path', query: 'arg=value', fragment: 'anchor'}
    var  o   = {
        strictMode: false,
        key: ["source","protocol","authority","userInfo","user","password","host","port","relative","path","directory","file","query","anchor"],        q:   {
            name:   "queryKey",
            parser: /(?:^|&)([^&=]*)=?([^&]*)/g
        },
        parser: {            strict: /^(?:([^:\/?#]+):)?(?:\/\/((?:(([^:@]*):?([^:@]*))?@)?([^:\/?#]*)(?::(\d*))?))?((((?:[^?#\/]*\/)*)([^?#]*))(?:\?([^#]*))?(?:#(.*))?)/,
            loose:  /^(?:(?![^:@]+:[^:@\/]*@)([^:\/?#.]+):)?(?:\/\/\/?)?((?:(([^:@]*):?([^:@]*))?@)?([^:\/?#]*)(?::(\d*))?)(((\/(?:[^?#](?![^?#\/]*\.[^?#\/.]+(?:[?#]|$)))*\/?)?([^?#\/]*))(?:\?([^#]*))?(?:#(.*))?)/ // Added one optional slash to post-protocol to catch file:/// (should restrict this)
        }
    };
        var m   = o.parser[o.strictMode ? "strict" : "loose"].exec(str),
    uri = {},
    i   = 14;
    while (i--) {uri[o.key[i]] = m[i] || "";}
    // Uncomment the following to use the original more detailed (non-PHP) script 
        uri[o.q.name] = {};
        uri[o.key[12]].replace(o.q.parser, function ($0, $1, $2) {
        if ($1) uri[o.q.name][$1] = $2;
        });        return uri;
    
 
    switch (component) {
        case 'PHP_URL_SCHEME':            return uri.protocol;
        case 'PHP_URL_HOST':
            return uri.host;
        case 'PHP_URL_PORT':
            return uri.port;        case 'PHP_URL_USER':
            return uri.user;
        case 'PHP_URL_PASS':
            return uri.password;
        case 'PHP_URL_PATH':            return uri.path;
        case 'PHP_URL_QUERY':
            return uri.query;
        case 'PHP_URL_FRAGMENT':
            return uri.anchor;        default:
            var retArr = {};
            if (uri.protocol !== '') {retArr.scheme=uri.protocol;}
            if (uri.host !== '') {retArr.host=uri.host;}
            if (uri.port !== '') {retArr.port=uri.port;}            if (uri.user !== '') {retArr.user=uri.user;}
            if (uri.password !== '') {retArr.pass=uri.password;}
            if (uri.path !== '') {retArr.path=uri.path;}
            if (uri.query !== '') {retArr.query=uri.query;}
            if (uri.anchor !== '') {retArr.fragment=uri.anchor;}            return retArr;
    }
}

var getElementsByClassName = function (className, tag, elm){
	if (document.getElementsByClassName) {
		getElementsByClassName = function (className, tag, elm) {
			elm = elm || document;
			var elements = elm.getElementsByClassName(className),
				nodeName = (tag)? new RegExp("\\b" + tag + "\\b", "i") : null,
				returnElements = [],
				current;
			for(var i=0, il=elements.length; i<il; i+=1){
				current = elements[i];
				if(!nodeName || nodeName.test(current.nodeName)) {
					returnElements.push(current);
				}
			}
			return returnElements;
		};
	}
	else if (document.evaluate) {
		getElementsByClassName = function (className, tag, elm) {
			tag = tag || "*";
			elm = elm || document;
			var classes = className.split(" "),
				classesToCheck = "",
				xhtmlNamespace = "http://www.w3.org/1999/xhtml",
				namespaceResolver = (document.documentElement.namespaceURI === xhtmlNamespace)? xhtmlNamespace : null,
				returnElements = [],
				elements,
				node;
			for(var j=0, jl=classes.length; j<jl; j+=1){
				classesToCheck += "[contains(concat(' ', @class, ' '), ' " + classes[j] + " ')]";
			}
			try	{
				elements = document.evaluate(".//" + tag + classesToCheck, elm, namespaceResolver, 0, null);
			}
			catch (e) {
				elements = document.evaluate(".//" + tag + classesToCheck, elm, null, 0, null);
			}
			while ((node = elements.iterateNext())) {
				returnElements.push(node);
			}
			return returnElements;
		};
	}
	else {
		getElementsByClassName = function (className, tag, elm) {
			tag = tag || "*";
			elm = elm || document;
			var classes = className.split(" "),
				classesToCheck = [],
				elements = (tag === "*" && elm.all)? elm.all : elm.getElementsByTagName(tag),
				current,
				returnElements = [],
				match;
			for(var k=0, kl=classes.length; k<kl; k+=1){
				classesToCheck.push(new RegExp("(^|\\s)" + classes[k] + "(\\s|$)"));
			}
			for(var l=0, ll=elements.length; l<ll; l+=1){
				current = elements[l];
				match = false;
				for(var m=0, ml=classesToCheck.length; m<ml; m+=1){
					match = classesToCheck[m].test(current.className);
					if (!match) {
						break;
					}
				}
				if (match) {
					returnElements.push(current);
				}
			}
			return returnElements;
		};
	}
	return getElementsByClassName(className, tag, elm);
};