function loadSettingsMain()
{
	try {
		System.Gadget.onSettingsClosing = settingsClosing;
		
		init();

		System.Gadget.Settings.write("browserPath", settings["browserPath"]);
		generateSettingsGui();
	} catch(exception) {
		log("loadSettingsMain: " + exception.name + ", " + exception.message);
	}
}

function settingsClosing(event)
{
    if (event.closeAction == event.Action.commit)
    {
    	bookmarkSetNames[selectedBookmarkSet] = document.getElementById("bookmarkSetLabel").value;
    	saveBookmarks();
    	setSetting("focusShortcuts", convertShortcutsString2System(document.getElementById("focusShortcuts").value));
    	setSetting("addBookmarkShortcuts", convertShortcutsString2System(document.getElementById("addBookmarkShortcuts").value));
    	setSetting("smartConnectionDirectCall", document.getElementById("settingsSmartConnectionDirectCall").value);
    	setSetting("showTutorialIcon", document.getElementById("settingsShowInfosTutorialIcon").value);
    	setSetting("showSmartConnectionInfo", document.getElementById("settingsShowInfosSmartConnection").value);
    }
}

function updateBookmarkSetName() {
	bookmarkSetNames[selectedBookmarkSet] = document.getElementById("bookmarkSetLabel").value;
}

function selectPreviousBookmarkSet() {
	try {
		var previousBookmarkSet = getPreviousBookmarkSet();
		if (previousBookmarkSet != undefined) {
	    	bookmarkSetNames[selectedBookmarkSet] = document.getElementById("bookmarkSetLabel").value;
	    	saveBookmarks();
			selectedBookmarkSet = previousBookmarkSet;
			System.Gadget.Settings.write("selectedBookmarkSet", selectedBookmarkSet);
			generateSettingsGui();
		}
	} catch(exception) {
		log("selectPreviousBookmarkSet: " + exception.name + ", " + exception.message);
	}
}

function selectNextBookmarkSet() {
	try {
		var nextBookmarkSet = getNextBookmarkSet();
		if (nextBookmarkSet != undefined) {
	    	bookmarkSetNames[selectedBookmarkSet] = document.getElementById("bookmarkSetLabel").value;
	    	saveBookmarks();
			selectedBookmarkSet = nextBookmarkSet;
			System.Gadget.Settings.write("selectedBookmarkSet", selectedBookmarkSet);
			generateSettingsGui();
		}
	} catch(exception) {
		log("selectNextBookmarkSet: " + exception.name + ", " + exception.message);
	}
}

function addBookmarkSet() {
	try {
		bookmarkSetNames[selectedBookmarkSet] = document.getElementById("bookmarkSetLabel").value;
		var maxBookmarkSet = 0;
		for (var bookmarkSet in bookmarks) {
			if (bookmarkSet > maxBookmarkSet) {
				maxBookmarkSet = bookmarkSet;
			}
		}
		selectedBookmarkSet = (parseInt(maxBookmarkSet) + 1);
		System.Gadget.Settings.write("selectedBookmarkSet", selectedBookmarkSet);
		bookmarks[selectedBookmarkSet] = new Array();
		bookmarkCommands[selectedBookmarkSet] = new Array();
		bookmarkLabels[selectedBookmarkSet] = new Array();
		bookmarkSetNames[selectedBookmarkSet] = l.get("bookmarkSetDefaultName") + "-" + selectedBookmarkSet;
		bookmarkIcons[selectedBookmarkSet] = new Array();
		bookmarkShortcuts[selectedBookmarkSet] = new Array();
		intelligentDialogs[selectedBookmarkSet] = new Array();
		searchHistory[selectedBookmarkSet] = new Array();
		saveBookmarks();
		
		generateSettingsGui();
	} catch(exception) {
		log("addBookmarkSet: " + exception.name + ", " + exception.message);
	}
}

function changeIcon()
{
	try {
		bookmarkId = document.getElementById("bookmarkDetailsBookmarkId").value;
		var item = System.Shell.chooseFile(true, "*", "C:\\", "");
		if (item)
		{
			updateIcon(bookmarkId, item.path);
			document.getElementById("bookmarkDetailsImage").src = imageSrc(bookmarkIcons[selectedBookmarkSet][bookmarkId], 32);
		}
	} catch (exception) {
		log("changeIcon: "+exception.name+", "+exception.message);
	}
}

function updateIcon(bookmarkId, iconPath)
{
	bookmarkIcons[selectedBookmarkSet][bookmarkId] = iconPath;
	saveBookmarks();
}

function addApplicationBookmark()
{
	var item = System.Shell.chooseFile(true, "*", "C:\\", "");
	if (item)
	{
		addBookmark(item.path);
		generateSettingsGui();
	}
	hideAddBookmarkDialog();
}

function deleteCheckedBookmark()
{
	try {
		for (i = 0; i < document.getElementsByTagName("input").length; i++)
		{
			if (document.getElementsByTagName("input")[i].name == "bookmarkChecks" && document.getElementsByTagName("input")[i].checked == true)
			{
				deleteBookmark(document.getElementsByTagName("input")[i].value);
				generateSettingsGui();
			}
		}
	} catch (exception) {
		log("deleteCheckedBookmark: "+exception.name+", "+exception.message);
	}
}

function showAddBookmarkDialog()
{
	document.getElementById("existingBookmarksDiv").style.display = "none";
	document.getElementById("addBookmarksDiv").style.display = "block";
	document.getElementById("bookmarkDetailsDiv").style.display = "none";
	document.getElementById("dividerDetailsDiv").style.display = "none";
	document.getElementById("addBookmarkUrlDiv").style.display = "none";
	document.getElementById("newdividerDiv").style.display = "none";
	document.getElementById("addBookmarkUrl").value = "http://";
	document.getElementById("addBookmarkButton").style.display = "none";
	document.getElementById("bookmarkSetsDiv").style.display = "none";

}

function hideAddBookmarkDialog()
{
	document.getElementById("existingBookmarksDiv").style.display = "block";
	document.getElementById("addBookmarksDiv").style.display = "none";
	document.getElementById("bookmarkDetailsDiv").style.display = "none";
	document.getElementById("dividerDetailsDiv").style.display = "none";
	document.getElementById("addBookmarkButton").style.display = "block";
	document.getElementById("bookmarkSetsDiv").style.display = "block";
}

function convertShortcutsSystem2String(shortcutsStr) {
	keyCodes = shortcutsStr.match(/[0-9]+/g);
	for (var i = 0; keyCodes && i < keyCodes.length; i++) {
		keyCodes[i] = keyCodes[i].replace(/ /g, "");
		shortcutsStr = shortcutsStr.replace(keyCodes[i], DDBookmarksAXO.getStringForKeyCode(keyCodes[i]));
	}
	shortcutsStr = shortcutsStr.replace(/,/g, " , ").replace(/\+/g, " + ");
	if (shortcutsStr != "") {
		shortcutsStr += " , ";
	}
	shortcutsStr = shortcutsStr;
	
	return shortcutsStr;
}

function convertShortcutsString2System(shortcutsStr) {
	shortcutsStr = shortcutsStr;
	keys = shortcutsStr.match(/(?:[^a-zA-Z0-9]|^)([a-zA-Z0-9]+)(?:[^a-zA-Z0-9]|$)/g);
	for (var i = 0; keys && i < keys.length; i++) {
		keys[i] = keys[i].replace(/ /g, "");
		shortcutsStr = shortcutsStr.replace(keys[i], DDBookmarksAXO.getKeyCodeForString(keys[i]));
	}
	shortcutsStr = shortcutsStr.replace(/ /g, "").replace(/,$/, "");
	
	return shortcutsStr;
}

function showBookmarkDetails(bookmarkId) {
	try {
		document.getElementById("bookmarkDetailsDiv").style.display = "block";
		document.getElementById("dividerDetailsDiv").style.display = "none";
		document.getElementById("existingBookmarksDiv").style.display = "none";
		document.getElementById("bookmarkSetsDiv").style.display = "none";
		document.getElementById("addBookmarkButton").style.display = "none";
		document.getElementById("addBookmarkLine").style.display = "none";
		document.getElementById("bookmarkDetailsBookmarkId").value = bookmarkId;
		var command = bookmarks[selectedBookmarkSet][bookmarkId];
		if (isLocalPath(command)) {
			command = command.replace(/\\\\/g, "\\");
		}
		document.getElementById("bookmarkDetailsCommand").value = command;
//		if (isDefaultBookmark(bookmarkCs[selectedBookmarkSet][bookmarkId])) {
//			document.getElementById("bookmarkDetailsCommand").disabled = true;
//		} else {
//			document.getElementById("bookmarkDetailsCommand").disabled = false;
//		}
		document.getElementById("bookmarkDetailsLabel").value = bookmarkLabels[selectedBookmarkSet][bookmarkId];
		document.getElementById("bookmarkDetailsImage").src = imageSrc(bookmarkIcons[selectedBookmarkSet][bookmarkId], 32);
		if (identifyLinkType(bookmarkCommands[selectedBookmarkSet][bookmarkId]) == "website") {
			document.getElementById("crawlingIconButton").style.display = "block";
			document.getElementById("crawlingIconLoaderbar").style.display = "none";
		} else {
			document.getElementById("crawlingIconButton").style.display = "none";
			document.getElementById("crawlingIconLoaderbar").style.display = "none";
		}
		
		var shortcutsStr = convertShortcutsSystem2String(bookmarkShortcuts[selectedBookmarkSet][bookmarkId]);

		document.getElementById("bookmarkDetailsShortcuts").value = shortcutsStr;
	} catch (exception) {
		log("showBookmarkDetails: "+exception.name+", "+exception.message);
	}
}

function showDividerDetails(bookmarkId) {
	try {
		document.getElementById("dividerDetailsDiv").style.display = "block";
		document.getElementById("bookmarkDetailsDiv").style.display = "none";
		document.getElementById("existingBookmarksDiv").style.display = "none";
		document.getElementById("bookmarkSetsDiv").style.display = "none";
		document.getElementById("addBookmarkButton").style.display = "none";
		document.getElementById("addBookmarkLine").style.display = "none";
		document.getElementById("dividerDetailsBookmarkId").value = bookmarkId;
		document.getElementById("dividerDetailsLabel").value = bookmarks[selectedBookmarkSet][bookmarkId].replace(String.fromCharCode(2), "");
	} catch (exception) {
		log("showDividerDetails: "+exception.name+", "+exception.message);
	}
}

function hideBookmarkDetails() {
	document.getElementById("bookmarkDetailsDiv").style.display = "none";
	document.getElementById("existingBookmarksDiv").style.display = "block";
	document.getElementById("bookmarkSetsDiv").style.display = "block";
	document.getElementById("addBookmarkButton").style.display = "block";
	document.getElementById("addBookmarkLine").style.display = "block";
}

function hideDividerDetails() {
	document.getElementById("dividerDetailsDiv").style.display = "none";
	document.getElementById("existingBookmarksDiv").style.display = "block";
	document.getElementById("bookmarkSetsDiv").style.display = "block";
	document.getElementById("addBookmarkButton").style.display = "block";
	document.getElementById("addBookmarkLine").style.display = "block";
}

function addWebsiteBookmark()
{
	try {
		var url = document.getElementById("addBookmarkUrl").value;
		if (!url.match(/^(http|ftp|https)\:\/\/.+/i)) {
			url = "http://" + url;
		}
		if (url != "http://" && url.match(/^(http|ftp|https)\:\/\/.+/i))
		{
			addBookmark(url);
			generateSettingsGui();
			hideAddBookmarkDialog();
		}
		else
		{
			document.getElementById("addUrlBookmarkErrors").innerHTML = l.get("urlNotValid");
			setTimeout("document.getElementById('addUrlBookmarkErrors').innerHTML=''", 6000);
		}
	} catch (exception) {
		log("addWebsiteBookmark: "+exception.name+", "+exception.message);
	}
}

function addDividerSettings()
{
	try {
		var dividerName = document.getElementById("newdividerName").value;
		
		addBookmark(String.fromCharCode(2) + dividerName, true);
		generateSettingsGui();
		hideAddBookmarkDialog();
	} catch (exception) {
		log("addDividerSettings: " + exception.name + ", " + exception.message);
	}
}

function updateIconImagesSettings() {
	
	for (i = 0; i < bookmarks[selectedBookmarkSet].length; i++)
	{
		if (document.getElementById("bookmarkImage-" + selectedBookmarkSet + "-" + i)) {
			document.getElementById("bookmarkImage-" + selectedBookmarkSet + "-" + i).src = imageSrc(bookmarkIcons[selectedBookmarkSet][i], 16);
		}
	}
	document.getElementById("crawlingIconLoaderbar").style.display = "none";
	if (document.getElementById("bookmarkDetailsBookmarkId").value != "") {
		document.getElementById("bookmarkDetailsImage").src = imageSrc(bookmarkIcons[selectedBookmarkSet][document.getElementById("bookmarkDetailsBookmarkId").value], 32);
	}
	
}

function saveBookmarkDetails() {
	try {
		var bookmarkId = document.getElementById("bookmarkDetailsBookmarkId").value;
		var shortcutsStr = convertShortcutsString2System(document.getElementById("bookmarkDetailsShortcuts").value);
		bookmarks[selectedBookmarkSet][bookmarkId] = document.getElementById("bookmarkDetailsCommand").value;
		bookmarkCommands[selectedBookmarkSet][bookmarkId] = document.getElementById("bookmarkDetailsCommand").value;
		bookmarkLabels[selectedBookmarkSet][bookmarkId] = document.getElementById("bookmarkDetailsLabel").value;
		bookmarkShortcuts[selectedBookmarkSet][bookmarkId] = shortcutsStr;
		saveBookmarks();
	} catch (exception) {
		log("saveBookmarkDetails: "+exception.name+", "+exception.message);
	}
}

function saveDividerDetails() {
	try {
		var bookmarkId = document.getElementById("dividerDetailsBookmarkId").value;
		bookmarks[selectedBookmarkSet][bookmarkId] = String.fromCharCode(2) + document.getElementById("dividerDetailsLabel").value;
		saveBookmarks();
	} catch (exception) {
		log("saveDividerDetails: "+exception.name+", "+exception.message);
	}
}

function getCursorPos(textElement) {
	var sOldText  = textElement.value;
	var objRange  = document.selection.createRange();
	var sOldRange = objRange.text;
	var sWeirdString = '#%~';
	objRange.text = sOldRange + sWeirdString;
	objRange.moveStart('character', (0 - sOldRange.length - sWeirdString.length));
	var sNewText  = textElement.value;
	objRange.text = sOldRange;
	 for (i=0; i <= sNewText.length; i++) {
	  var sTemp   = sNewText.substring(i, i + sWeirdString.length);
	  if (sTemp  == sWeirdString) {
	    var cursorPos = (i - sOldRange.length);
	    return cursorPos;
	  }
	 }
	}
function addKeyboardKeys(obj) {
	try {
		var del1 = DDBookmarksAXO.isKeyPressed("test", 46, false);
		var del2 = DDBookmarksAXO.isKeyPressed("test", 8, false);
		if (del1 || del2) {
			var cursorPos = getCursorPos(obj);
			var begin = obj.value.substr(0, cursorPos).lastIndexOf(" , ");
			var end = cursorPos + obj.value.substr(cursorPos, obj.value.length - cursorPos).indexOf(" , ");
			valu = obj.value;
			var first = obj.value.substr(0, begin);
			var last = obj.value.substr(end, obj.value.length - end + 1)
			if (last == " ")
				last = "";
			obj.value = first + last;
			obj.value = obj.value.replace(/(^ , | , $|^ , $)/g, "");
//			if (obj.value.substr(0, 3) == " , ") {
//				obj.value = obj.value.substr(3);
//			}
//			if (obj.value.substr(obj.value.length - 3, 3) == " , ") {
//				obj.value = obj.value.substr(0, obj.value.length - 3);
//			}
			return;
		}
		var key = DDBookmarksAXO.indicatePressedKeys("indicateKeys1");
		if (key != -1) {
			if (obj.value != "" && obj.value.substr(obj.value.length - 2, 2) != ", ") {
				obj.value += " + ";
			}
			obj.value += DDBookmarksAXO.getStringForKeyCode(key);
		}
        if (DDBookmarksAXO.finishedKeyboardKeys("indicateKeys1"))
        {
        	if (obj.value.substr(obj.value.length - 2, 2) != ", ") {
        		obj.value += " , ";
        	}
        }
        
        if (obj.value != obj.value.replace(/(^ , |^ , $)/g, "")) {
        	obj.value = obj.value.replace(/(^ , |^ , $)/g, "");
        }
	//	if (!DDBookmarksAXO.finishedKeyboardKeys("indicateKeys1")) {
	//		setTimeout("addKeyboardKeys()", 100);
	//	}
	} catch (exception) {
		log("addKeyboardKeys: "+exception.name+", "+exception.message);
	}
}

function indicateKeyboardKeys(e, obj) {
	addKeyboardKeys(obj);
	return;
	var keys = new Array();
	if (e.altKey) {
		keys[keys.length] = "alt";
	}
	if (e.ctrlKey) {
		keys[keys.length] = "strg";
	}
	if (e.ctrlLeft) {
		keys[keys.length] = "strgLeft";
	}
	if (e.shiftKey) {
		keys[keys.length] = "shift";
	}
	if (e.shiftLeft) {
		keys[keys.length] = "shiftLeft";
	}
	character = String.fromCharCode(e.keyCode).toLowerCase();
	if(code == 188) character=","; //If the user presses , when the type is onkeydown
	if(code == 190) character="."; //If the user presses , when the type is onkeydown

	obj.value = keys.join(" + ");
}

function generateSettingsGui()
{
	try {
		if (System.Gadget.Settings.read("installedVersion") != System.Gadget.version.replace(/\./g,",")) {
			document.getElementById("newVersionProblemInfoDiv").style.display = "block";
			// in future: add this
			// getSetting("downloadedVersion") != System.Gadget.version && 
		} else if ((getSetting("lastNewFunctionInfo") == "" || getSetting("lastNewFunctionInfo") != System.Gadget.version) && l.get("newFunctions") != "") {
			document.getElementById("newFunctionsInfoDiv").style.display = "block";
		}
		
		hideAddBookmarkDialog();
		hideBookmarkDetails();
		loadIntelligentDialogInfo();
		indicateDialogInfos();
		if (getPreviousBookmarkSet() != undefined) {
			document.getElementById("previousBookmarkSetArrow").style.display = "block";
		} else {
			document.getElementById("previousBookmarkSetArrow").style.display = "none";
		}
		if (getNextBookmarkSet() != undefined) {
			document.getElementById("nextBookmarkSetArrow").style.display = "block";
		} else {
			document.getElementById("nextBookmarkSetArrow").style.display = "none";
		}
		if (arrayLength(bookmarks) > 1) {
			document.getElementById("deleteBookmarkSetImage").style.display = "inline";
			document.getElementById("bookmarkSetLabel").style.display = "inline";
		} else {
			document.getElementById("deleteBookmarkSetImage").style.display = "none";
			document.getElementById("bookmarkSetLabel").style.display = "none";
		}
		document.getElementById("bookmarkSetLabel").value = bookmarkSetNames[selectedBookmarkSet];
		
		document.getElementById("addBookmarkButton").style.display = "block";
		document.getElementById("addBookmarkLine").style.display = "block";
		if (typeof getSetting("browserPath") == "undefined" || getSetting("browserPath") == "undefined")
		{
			document.getElementById("browserName").innerHTML = "internet explorer";
		}
		else
		{
			document.getElementById("browserName").innerHTML = oFSO.GetFileName(getSetting("browserPath")).replace(".exe", "");
		}
		document.getElementById("focusShortcuts").value = convertShortcutsSystem2String(getSetting("focusShortcuts"));
		document.getElementById("addBookmarkShortcuts").value = convertShortcutsSystem2String(getSetting("addBookmarkShortcuts"));
		document.getElementById("settingsShowInfosTutorialIcon").value = getSetting("showTutorialIcon");
		document.getElementById("settingsShowInfosSmartConnection").value = getSetting("showSmartConnectionInfo");
		document.getElementById("settingsSmartConnectionDirectCall").value = getSetting("smartConnectionDirectCall");

		bookmarksT = document.getElementById("bookmarksTable");
		while (bookmarksT.rows.length > 0)
		{
			bookmarksT.deleteRow(0);
		}
		for (i = 0; i < bookmarks[selectedBookmarkSet].length; i++)
		{
			bookmarkRow = bookmarksT.insertRow(i);
			bookmarkRow.className = "draggable";
			cell = bookmarkRow.insertCell();
			cell.style.cursor = "pointer";
			cell.alt = i;
			input = document.createElement("input");
			input.setAttribute("type", "hidden");
			input.id = "check-"+i;
			input.value = bookmarks[selectedBookmarkSet][i];
			input.name = "bookmarkChecks";
			cell.appendChild(input);
			moveImg = document.createElement("img");
			moveImg.src = gadgetFolderPrefix + "images/up_down.png";
			moveImg.style.width = "16px";
			moveImg.style.height = "16px";
			moveImg.title = l.get("settingsMoveBookmark");
			cell.appendChild(moveImg);
			if (identifyLinkType(bookmarks[selectedBookmarkSet][i]) == "divider") {
				cell = bookmarkRow.insertCell();
				cell.style.cursor = "hand";
				cell.name = i;
				cell.alt = i;
				cell.title = l.get("settingsEditBookmark");
				cell.onclick = function() {
					showDividerDetails(this.alt);
				}

				cell.innerHTML = "<i>" + l.get("divider") + ": " + bookmarks[selectedBookmarkSet][i].replace(/\\\\/g, "\\").replace(String.fromCharCode(2), "");
				cell.colSpan = "2";
			} else {
				cell = bookmarkRow.insertCell();
				bookmarkImg = document.createElement("img");
				bookmarkImg.src = imageSrc(bookmarkIcons[selectedBookmarkSet][i], 16);
				bookmarkImg.width = 16;
				bookmarkImg.height = 16;
				bookmarkImg.id = "bookmarkImage-" + selectedBookmarkSet + "-" + i;
				cell.appendChild(bookmarkImg);
				cell = bookmarkRow.insertCell();
				cell.style.cursor = "hand";
				cell.name = i;
				cell.alt = i;
				cell.title = l.get("settingsEditBookmark");
				cell.onclick = function() {
					showBookmarkDetails(this.alt);
				}

				cell.innerHTML = bookmarkLabels[selectedBookmarkSet][i];
			}
		}
		addBookmarksT = document.getElementById("addBookmarksTable");
		while (addBookmarksT.rows.length > 0)
		{
			addBookmarksT.deleteRow(0);
		}
		for (i = 0; i < defaultBookmarks.length; i++)
		{
			defaultBookmarkRow = addBookmarksT.insertRow(i);
			cell = defaultBookmarkRow.insertCell();
			defaultBookmarkImg = document.createElement("img");
			defaultBookmarkImg.src = gadgetFolderPrefix + "images/"+defaultBookmarks[i].toLowerCase()+".png";
			defaultBookmarkImg.title = defaultBookmarkCommands[i];
			defaultBookmarkImg.width = 32;
			defaultBookmarkImg.height = 32;
			defaultBookmarkImg.style.cursor = "hand";
			defaultBookmarkImg.onclick = function (e) {
				addBookmark(this.title);
				generateSettingsGui();
			}
			cell.width = 40;
			cell.appendChild(defaultBookmarkImg);
			cell = defaultBookmarkRow.insertCell();
			cell.style.cursor = "hand";
			cell.title = defaultBookmarkCommands[i];
			cell.onclick = function (e) {
				addBookmark(this.title);
				generateSettingsGui();
			}
			cell.name = i;
			cell.innerHTML = defaultBookmarks[i];
			cell = defaultBookmarkRow.insertCell();
			cell.width = 24;
			cell.innerHTML = "&nbsp;";
			cell.id = "idInfo-" + i;
			cell = defaultBookmarkRow.insertCell();
			cell.width = 24;
			cell.innerHTML = "&nbsp;";
			for (j = 0; j < bookmarkCommands[selectedBookmarkSet].length; j++)
			{
				if (bookmarkCommands[selectedBookmarkSet][j] == defaultBookmarkCommands[i])
				{
					cell.style.backgroundImage = "url(" + gadgetFolderPrefix + "images/bookmark.png)";
					cell.style.backgroundRepeat = "no-repeat";
					cell.title = l.get("bookmarkSetted");
				}
			}
			if (defaultBookmarks[i].toLowerCase() == "smartconnection") {
				document.getElementById("addBookmarksTable").moveRow(cell.parentNode.rowIndex, 0);
			} else {
				cell = defaultBookmarkRow.insertCell();
				cell.width = 24;
				cell.innerHTML = "&nbsp;";
				cell.style.backgroundImage = "url(" + gadgetFolderPrefix + "images/search.png)";
				cell.style.backgroundRepeat = "no-repeat";
				cell.style.cursor = "pointer";
				cell.title = l.get("settingsDefaultBookmarksCall") + ": " + defaultBookmarkCommands[i];
				cell.alt = defaultBookmarkCommands[i];
				cell.onclick = function (e) {
					callBookmark(this.alt, true, true);
				}
			}
		}
		
		backgroundT = document.getElementById("backgroundTable");
		while (backgroundT.rows.length > 0)
		{
			backgroundT.deleteRow(0);
		}
		backgroundImages = getAllAvailableBackgroundImages();
		for (i = 0; i < backgroundImages.length; i++)
		{
			if (i % 3 == 0) {
				backgroundRow = backgroundT.insertRow(i / 3);
			}
			cell = backgroundRow.insertCell();
			backgroundImageImg = document.createElement("img");
			backgroundImageImg.src = getBackgroundPath(backgroundImages[i]);
			if (getBackgroundPath(backgroundImages[i]) == getBackgroundPath(getSetting("backgroundImage"))) {
				backgroundImageImg.style.border = "4px solid #CCC";
			} else {
				backgroundImageImg.style.border = "1px solid #BBB";
				backgroundImageImg.style.margin = "3px";
			}
			backgroundImageImg.title = backgroundImages[i];
			backgroundImageImg.style.width = "70px";
			backgroundImageImg.style.height = "70px";
			backgroundImageImg.style.cursor = "hand";
			backgroundImageImg.onclick = function (e) {
				setSetting("backgroundImage", this.title);
				loadSettingsMain();
				System.Gadget.document.body.style.backgroundImage = "url("+getBackgroundPath(getSetting("backgroundImage"))+")";
			}
			cell.onmouseover = function (e) {
				this.style.border = "2px solid #AAA";
			}
			cell.onmouseout = function (e) {
				this.style.border = "2px dotted #FFF";
			}
			cell.style.border = "2px dotted #FFF";
			cell.appendChild(backgroundImageImg);
			cell.style.cursor = "hand";
			cell.title = backgroundImages[i];
			cell.onclick = function (e) {
				selectBackgroundImage(this.title);
			}
			cell.style.textAlign = "center";
		}
		
		fontColorT = document.getElementById("fontColorTable");
		while (fontColorT.rows.length > 0)
		{
			fontColorT.deleteRow(0);
		}
		fontColors = new Array("000000", "666666", "BBBBBB", "FFFFFF", "FF0000", "FF10FF", "0000FF", "00FFFF", "00FF00", "FFFF00", "7F0000", "7F007F", "00007F", "007F7F", "007F00", "827F00");
		for (i = 0; i < fontColors.length; i++)
		{
			if (i % 6 == 0) {
				fontColorRow = fontColorT.insertRow(i / 6);
			}
			cell = fontColorRow.insertCell();
			fontColorTile = document.createElement("div");
			if (fontColors[i] == getSetting("infoFontColor")) {
				fontColorTile.style.border = "4px solid #CCC";
			} else {
				fontColorTile.style.border = "1px solid #BBB";
				fontColorTile.style.margin = "3px";
			}
			fontColorTile.title = fontColors[i];
			fontColorTile.style.width = "25px";
			fontColorTile.style.height = "15px";
			fontColorTile.style.cursor = "hand";
			fontColorTile.style.background = "#" + fontColors[i];
			cell.title = fontColors[i];
			cell.onclick = function (e) {
				setSetting("infoFontColor", this.title);
				loadSettingsMain();
			}
			cell.onmouseover = function (e) {
				this.style.border = "2px solid #AAA";
			}
			cell.onmouseout = function (e) {
				this.style.border = "2px dotted #FFF";
			}
			cell.style.border = "2px dotted #FFF";
			cell.appendChild(fontColorTile);
			cell.style.cursor = "hand";
			cell.style.textAlign = "center";
		}
		
		var elems = bookmarksTable.getElementsByTagName("tr");
		
		for (var i = 0; i < elems.length; i++)
		{
			if (elems[i].className.match(/draggable/)) {
				var childElem = elems[i].childNodes[0];
				Drag.init(childElem);
				childElem.onDrag = function(y,myElem)
				{
					y = myElem.parentNode.offsetTop;
					calcOffsets();
					
					myElem.parentNode.style.zIndex = 99;
					var pos = whereAmI(myElem.parentNode);
					var elems = bookmarksT.getElementsByTagName("tr");
					if (pos != elems.length-1 && y > offsets[pos+1])
					{ 
						if (elems[pos+2]) 
							myElem.parentNode.parentNode.insertBefore(myElem.parentNode, elems[pos+2]);
						else 
							myElem.parentNode.parentNode.appendChild(myElem.parentNode);
						myElem.parentNode.style.pixelTop = 0;                
					}
					if (pos != 0 && y < offsets[pos-1])
					{
						myElem.parentNode.parentNode.insertBefore(myElem.parentNode, elems[pos-1]);
						myElem.parentNode.style.pixelTop = 0;
					}
	
				};
				childElem.onDragEnd = function(myElem)
				{
					checkedId = myElem.parentNode.childNodes[0].childNodes[0].id;
					var pos = whereAmI(myElem.parentNode);
					myElem.parentNode.style.pixelTop = 0;
					myElem.parentNode.style.pixelLeft = 0;                
					myElem.parentNode.style.zIndex = 1;
					objs = getBookmarkCheckboxes();
					bookmarksTmp = new Array();
					bookmarkCommandsTmp = new Array();
					bookmarkLabelsTmp = new Array();
					bookmarkIconsTmp = new Array();
					bookmarkShortcutsTmp = new Array();
					intelligentDialogsTmp = new Array();
					searchHistoryTmp = new Array();
					for (i = 0; i < objs.length; i++)
					{
						bookmarkInd = objs[i].id.substr(6, objs[i].id.length - 6);
						bookmarksTmp[i] = bookmarks[selectedBookmarkSet][bookmarkInd];
						bookmarkCommandsTmp[i] = bookmarkCommands[selectedBookmarkSet][bookmarkInd];
						bookmarkLabelsTmp[i] = bookmarkLabels[selectedBookmarkSet][bookmarkInd];
						bookmarkIconsTmp[i] = bookmarkIcons[selectedBookmarkSet][bookmarkInd];
						bookmarkShortcutsTmp[i] = bookmarkShortcuts[selectedBookmarkSet][bookmarkInd];
						intelligentDialogsTmp[i] = intelligentDialogs[selectedBookmarkSet][bookmarkInd];
						searchHistoryTmp[i] = searchHistory[selectedBookmarkSet][bookmarkInd];
					}
	
					bookmarks[selectedBookmarkSet] = bookmarksTmp;
					bookmarkCommands[selectedBookmarkSet] = bookmarkCommandsTmp;
					bookmarkLabels[selectedBookmarkSet] = bookmarkLabelsTmp;
					bookmarkIcons[selectedBookmarkSet] = bookmarkIconsTmp;
					bookmarkShortcuts[selectedBookmarkSet] = bookmarkShortcutsTmp;
					intelligentDialogs[selectedBookmarkSet] = intelligentDialogsTmp;
					searchHistory[selectedBookmarkSet] = searchHistoryTmp;
					saveBookmarks();
					generateSettingsGui();
				}
			}
		}
		calcOffsets();
		
		document.getElementById("bookmarksPerLine").value = getSetting("bookmarksPerLine");
		
		if (getSetting("sendErrors") == 0) {
			document.getElementById("sendErrors").value = 0;
		}
			
		if (getSetting("shortcutsEnabled") == 0) {
			document.getElementById("shortcutsEnabled").value = 0;
		}
	} catch (exception) {
		log("generateSettingsGui: "+exception.name+", "+exception.message);
	}
}

function loadIntelligentDialogInfo()
{
	try {
		XMLHttp2DialogInfo = new ActiveXObject("Microsoft.XMLHTTP");
		XMLHttp2DialogInfo.open("GET", getCompletedUrl("http://www.digitaldiagnosis.de/dd_bookmarks_intelligentDialogs.php?getInfo&version="+System.Gadget.version+""), true);
		XMLHttp2DialogInfo.setRequestHeader( "If-Modified-Since", "Sat, 1 Jan 2000 00:00:00 GMT" );
		XMLHttp2DialogInfo.onreadystatechange=function() {
			if (XMLHttp2DialogInfo.readyState == 4)
			{
				intelligentDialogInfos = new Array();
				var content = XMLHttp2DialogInfo.ResponseText;
				if (content != null)
				{
					var intelligentDialogInfosSplits = content.split(String.fromCharCode(2));
					for (var i = 0; i < intelligentDialogInfosSplits.length; i++)
					{
						if (intelligentDialogInfosSplits[i] != "")
						{
							splits = intelligentDialogInfosSplits[i].split(String.fromCharCode(1));
							intelligentDialogInfos[i] = new Array();
							intelligentDialogInfos[i][0] = splits[0];
							splits = removeArrayElement(splits, 0);
							intelligentDialogInfos[i][1] = splits;
						}
					}
				}
			}
		}
		XMLHttp2DialogInfo.send();
	} catch (exception) {
		log("loadIntelligentDialogInfo: "+exception.name+", "+exception.message);
	}
}

function indicateDialogInfos() {
	try {
		if (intelligentDialogInfos instanceof Array && document.getElementById("addBookmarksTable").rows.length > 0)
		{
			for (var j = intelligentDialogInfos.length - 1; j >= 0 ; j--)
			{
				for (var k = 0; k < defaultBookmarkCommands.length; k++)
				{
					if (intelligentDialogInfos[j][0] == defaultBookmarkCommands[k])
					{
						cell = document.getElementById("idInfo-"+k);
						cell.style.backgroundImage = "url(" + gadgetFolderPrefix + "images/intelligentDialog.png)";
						cell.style.backgroundRepeat = "no-repeat";
						cell.title = intelligentDialogInfos[j][1][0];
						document.getElementById("addBookmarksTable").moveRow(cell.parentNode.rowIndex, 1);
					}
				}
			}
		}
		else
		{
			setTimeout("indicateDialogInfos()", 500);
		}
	} catch (exception) {
		log("indicateDialogInfos: "+exception.name+", "+exception.message);
	}
}

function getBookmarkCheckboxes()
{
	objs = new Array();
	
	for (var i = 0; i < document.getElementsByTagName("input").length; i++)
	{
		if (document.getElementsByTagName("input")[i].id.substr(0,6) == "check-")
		{
			objs[objs.length] = document.getElementsByTagName("input")[i];
		}
	}
	
	return objs;
}

function chooseBrowser()
{
	var item = System.Shell.chooseFile(true, "Application:*.exe", "C:\\", "");
	if (item)
	{
		setSetting("browserPath", item.path);
		loadSettingsMain();
	}
}

function selectBackgroundImageByDialog() {
	try {
		var item = System.Shell.chooseFile(true, "Application:*.*", "C:\\", "");
		if (item)
		{
			folderPath = System.Gadget.path + "\\general\\images\\backgrounds\\";
			var folder = "";
			splits = (folderPath).split("\\");
			for (var i = 0; i < (splits.length - 1); i++) {
				folder += splits[i] + "\\";
				if (oFSO.FolderExists(folder) === false) {
					oFSO.CreateFolder(folder);
				}
			}
			customImagesFolder = oFSO.getFolder(folderPath);
		    for (files = new Enumerator(customImagesFolder.files); !files.atEnd(); files.moveNext())
		    {
		        var customFile = files.item();
		        if (customFile.name.substr(0, 6) == "custom") {
		        	customFile.Delete();
		        }
		    }
		    fileName = "custom." + item.name.substr(item.name.length - 3, 3);
			oFSO.CopyFile(item.path, getBackgroundPath(fileName), true);
			setSetting("backgroundImage", fileName);
			loadSettingsMain();
		}
	} catch (exception) {
		log("selectBackgroundImageByDialog: "+exception.name+", "+exception.message);
	}
}

function log(message){addError(message);}

/**************************************************
 * originally "dom-drag.js"
 * 09.25.2001
 * www.youngpup.net
 **************************************************
 * 10.28.2001 - fixed minor bug where events
 * sometimes fired off the handle, not the root.
 **************************************************/

/**************************************************
 * modified by Dean Laforet, Dietmar Sauer
 **************************************************/

var Drag = {

	obj : null,
	parentObj : null,

	init : function(obj){
		obj.onmousedown	= Drag.start;
		obj.parentNode.style.pixelTop = 0;
		obj.onDragStart = new Function();
		obj.onDragEnd = new Function();
		obj.onDrag = new Function();
	},

	start : function(e){
		Drag.obj = this;
		Drag.parentObj = this.parentNode;
		e = Drag.fixE(e);
		Drag.parentObj.lastMouseY = e.clientY;
		document.onmousemove = Drag.drag;
		document.onmouseup = Drag.end;
		return false;
	},

	drag : function(e){
		e = Drag.fixE(e);
		var ey	= e.clientY;
		var y = parseInt(Drag.obj.parentNode.style.pixelTop);
		var ny = parseInt(y + ey - Drag.obj.parentNode.lastMouseY);
		Drag.obj.parentNode.style.pixelTop = ny;
		Drag.obj.parentNode.style.pixelLeft = 10;
		Drag.obj.parentNode.lastMouseY	= ey;
		Drag.obj.onDrag(ny, Drag.obj);
		return false;
	},

	end : function(){
		document.onmousemove = null;
		document.onmouseup = null;
		Drag.obj.onDragEnd(Drag.obj);
		Drag.obj = null;
	},

	fixE : function(e){
		if (typeof e == 'undefined') e = window.event;
		return e;
	}
};

var offsets = new Array();

function calcOffsets(){
  var oElems = document.getElementById("bookmarksTable").getElementsByTagName("tr");
  for (var i = 0; i < oElems.length; i++){
	childElem = oElems[i];
    offsets[i] = childElem.offsetTop;
  }
}

function whereAmI(elem){ 
  var wElems = document.getElementById("bookmarksTable").getElementsByTagName("tr");
  for (var i = 0; i < wElems.length; i++){
	  childElem = wElems[i];
    if (childElem == elem) { return i }
  }
}

function saveDragged(){
try{
  bookmarks[selectedBookmarkSet][0] = bookmarks[selectedBookmarkSet][3];
  generateSettingsGui();
} catch(err) {log("saveDragged: "+err.name+" - "+err.message)}
}
